DECLARE
l_roles     OWA.VC_ARR;
  l_modules   OWA.VC_ARR;
  l_patterns  OWA.VC_ARR;
BEGIN
  ORDS.DEFINE_MODULE(
      p_module_name    => 'pra_pos_gas',
      p_base_path      => '/pra_pos_gas/',
      p_items_per_page =>  25,
      p_status         => 'PUBLISHED',
      p_comments       => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'artikl',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'artikl',
      p_method         => 'POST',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
    l_korisnik              VARCHAR2(40);
    l_shema VARCHAR2(40);

    /**
    * POST BODY PARAMETRI:
    *   id
    *   sifra
    */

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    execute immediate ''begin :artikl := '' || l_shema || ''PRA_POS_GAS.POSTOJI_ARTIKAL(:id, :sifra); end;'' using out :artikl, in :id, in :sifra;

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'artikl',
      p_method             => 'POST',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'artikl',
      p_method             => 'POST',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'artikl',
      p_method             => 'POST',
      p_name               => 'gas_id',
      p_bind_variable_name => 'artikl',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'artikl',
      p_method             => 'POST',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'artikl',
      p_method             => 'POST',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'cjenik',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'cjenik',
      p_method         => 'POST',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
    l_korisnik              VARCHAR2(40);
    l_shema VARCHAR2(40);

    /**
    * POST BODY PARAMETRI:
    *   id
    *   sifra
    */

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    execute immediate ''begin :cjenik := '' || l_shema || ''PRA_POS_GAS.POSTOJI_NACPOT(:id, :sifra); end;'' using out :cjenik, in :id, in :sifra;

    --:cjenik := PRA_POS_GAS.POSTOJI_NACPOT(:id, :sifra);

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'cjenik',
      p_method             => 'POST',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'cjenik',
      p_method             => 'POST',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'cjenik',
      p_method             => 'POST',
      p_name               => 'gas_id',
      p_bind_variable_name => 'cjenik',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'cjenik',
      p_method             => 'POST',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'cjenik',
      p_method             => 'POST',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'dnevni_obracun/postoji',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'dnevni_obracun/postoji',
      p_method         => 'POST',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
    l_korisnik              VARCHAR2(40);
    l_shema VARCHAR2(40);

    /**
    * POST BODY PARAMETRI:
    *   datum
    */

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    execute immediate ''begin :postoji_dnevni_obracun := '' || l_shema || ''PRA_POS_GAS.POSTOJI_DO(:datum); end;''
        using out :postoji_dnevni_obracun, in TO_DATE( :datum, ''RRRR-MM-dd"T"hh24:mi'' );

    --:postoji_dnevni_obracun := PRA_POS_GAS.POSTOJI_DO( TO_DATE( :datum, ''RRRR-MM-dd"T"hh24:mi'' ) );

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'dnevni_obracun/postoji',
      p_method             => 'POST',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'dnevni_obracun/postoji',
      p_method             => 'POST',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'dnevni_obracun/postoji',
      p_method             => 'POST',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'dnevni_obracun/postoji',
      p_method             => 'POST',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'dnevni_obracun/postoji',
      p_method             => 'POST',
      p_name               => 'postoji_dnevni_obracun',
      p_bind_variable_name => 'postoji_dnevni_obracun',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'gporez',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'gporez',
      p_method         => 'POST',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
    l_korisnik              VARCHAR2(40);
    l_shema VARCHAR2(40);

    /**
    * POST BODY PARAMETRI:
    *   id
    *   sifra
    */

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    execute immediate ''begin :gporez := '' || l_shema || ''PRA_POS_GAS.POSTOJI_GPOREZ(:id, :sifra); end;''
        using out :gporez, in :id, in :sifra;

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'gporez',
      p_method             => 'POST',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'gporez',
      p_method             => 'POST',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'gporez',
      p_method             => 'POST',
      p_name               => 'gas_id',
      p_bind_variable_name => 'gporez',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'gporez',
      p_method             => 'POST',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'gporez',
      p_method             => 'POST',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'gporezi',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'gporezi',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  25,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
    l_korisnik              VARCHAR2(40);
    l_shema VARCHAR2(40);

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    execute immediate ''begin :porezne_grupe := '' || l_shema || ''PRA_POS_GAS.GPOREZI; end;''
        using out :porezne_grupe;

    --:porezne_grupe := PRA_POS_GAS.GPOREZI;

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'gporezi',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'gporezi',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'gporezi',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'gporezi',
      p_method             => 'GET',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'gporezi',
      p_method             => 'GET',
      p_name               => 'porezne_grupe',
      p_bind_variable_name => 'porezne_grupe',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'jir',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'jir',
      p_method         => 'POST',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE

    -- jir
    l_GODINA VARCHAR2(5);
    l_KASE_ID NUMBER;
    l_RBR VARCHAR2(50);
    l_JIR VARCHAR2(40);
    l_ZASTITNI_KOD VARCHAR2(40);

    l_default_lang_ctx NUMBER;
    l_blob BLOB;
    l_clob clob;
    l_warning   NUMBER;
    l_offset NUMBER :=1;
    l_amount NUMBER;
    l_test VARCHAR2(50);

    l_broj_racuna NUMBER;

    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;
    api_exception exception;

    l_ords_api number := 2;
    l_korisnik              VARCHAR2(40);
    l_shema VARCHAR2(40);

    l_values apex_json.t_values;

    /**
    * POST BODY PARAMETRI:
    *[
		{
			"godina": "2017",
			"kase_id": 5067,
			"rbr": "000009",
			"jir": null,
			"zastitni_kod": null
        }
    ]
        */

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    l_blob := :body;
    l_default_lang_ctx := dbms_lob.default_lang_ctx;

    IF DBMS_LOB.getlength(l_blob) = 0 THEN
        RETURN;
    ELSE
        l_amount := DBMS_LOB.GETLENGTH(l_blob);
        DBMS_LOB.OPEN(l_blob, DBMS_LOB.LOB_READONLY);

        DBMS_LOB.CREATETEMPORARY(l_clob, TRUE);
        DBMS_LOB.CONVERTTOCLOB(
        dest_lob     => l_clob,
        src_blob     => l_blob,
        amount       => l_amount,
        dest_offset  => l_offset,
        src_offset   => l_offset,
        blob_csid    => nls_charset_id(''UTF8''),
        lang_context => l_default_lang_ctx,
        warning      => l_warning);

        DBMS_LOB.CLOSE(l_blob);
    END IF;

    apex_json.parse(l_values, l_clob);

    l_broj_racuna := apex_json.get_count(p_path => ''.'', p_values => l_values);

    FOR racun IN 1 .. nvl(l_broj_racuna,-1) LOOP

        l_GODINA := apex_json.get_varchar2(p_path => ''[%d].godina'', p0 => racun, p_values => l_values);
        l_KASE_ID := apex_json.get_number(p_path => ''[%d].kasa_id'', p0 => racun, p_values => l_values);
        l_RBR := apex_json.get_varchar2(p_path => ''[%d].rbr'', p0 => racun, p_values => l_values);
        l_ZASTITNI_KOD := apex_json.get_varchar2(p_path => ''[%d].zastitni_kod'', p0 => racun, p_values => l_values);
        l_JIR := apex_json.get_varchar2(p_path => ''[%d].jir'', p0 => racun, p_values => l_values);

        execute immediate ''begin '' || l_shema || ''PRA_POS_GAS.UCITAJ_JIR(:godina, :kase_id, :rbr, :zki, :jir); end;''
            using
                in l_GODINA,
                in l_KASE_ID,
                in l_RBR,
                in l_ZASTITNI_KOD,
                in l_JIR;

        /*pra_pos_gas.UCITAJ_JIR( l_GODINA,
                                l_KASE_ID,
                                l_RBR,
                                l_ZASTITNI_KOD,
                                l_JIR);*/
    END LOOP;

    :message := ''Podaci su uspješno upisani '' || l_broj_racuna;

    :status := 201;

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERS THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

end;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'jir',
      p_method             => 'POST',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'jir',
      p_method             => 'POST',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'jir',
      p_method             => 'POST',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'jir',
      p_method             => 'POST',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'kase',
      p_priority       => 0,
      p_etag_type      => 'NONE',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'kase',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  25,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
    l_korisnik              VARCHAR2(40);
    l_shema VARCHAR2(40);

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    execute immediate ''begin :kase := '' || l_shema || ''PRA_POS_GAS.KASE; end;''
        using out :kase;


    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase',
      p_method             => 'GET',
      p_name               => 'kase',
      p_bind_variable_name => 'kase',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase',
      p_method             => 'GET',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'kase/{kasa_id}/asortiman',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'kase/{kasa_id}/asortiman',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  25,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
    l_korisnik              VARCHAR2(40);
    l_shema VARCHAR2(40);

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    execute immediate ''begin :asortiman := '' || l_shema || ''PRA_POS_GAS.ASORTIMAN(:kasa_id); end;''
        using out :asortiman, in :kasa_id;


    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/asortiman',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/asortiman',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/asortiman',
      p_method             => 'GET',
      p_name               => 'asortiman',
      p_bind_variable_name => 'asortiman',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/asortiman',
      p_method             => 'GET',
      p_name               => 'kasa_id',
      p_bind_variable_name => 'kasa_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/asortiman',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/asortiman',
      p_method             => 'GET',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'kase/{kasa_id}/automatska_sinkronizacija',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'kase/{kasa_id}/automatska_sinkronizacija',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  25,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
l_korisnik              VARCHAR2(40);
l_shema VARCHAR2(40);

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    execute immediate ''begin :automatska_sinkronizacija := '' || l_shema || ''PRA_POS_GAS.AUTOMATSKA_SINKRONIZACIJA(:kasa_id); end;''
        using out :automatska_sinkronizacija, in :kasa_id;

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/automatska_sinkronizacija',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/automatska_sinkronizacija',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/automatska_sinkronizacija',
      p_method             => 'GET',
      p_name               => 'automatska_sinkronizacija',
      p_bind_variable_name => 'automatska_sinkronizacija',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/automatska_sinkronizacija',
      p_method             => 'GET',
      p_name               => 'kasa_id',
      p_bind_variable_name => 'kasa_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/automatska_sinkronizacija',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/automatska_sinkronizacija',
      p_method             => 'GET',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'kase/{kasa_id}/automatska_sinkronizacija',
      p_method         => 'PUT',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
    l_korisnik              VARCHAR2(40);
    l_shema VARCHAR2(40);

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    execute immediate ''begin '' || l_shema || ''PRA_POS_GAS.AZURIRAJ_OZN_SINKRONIZACIJE(:kasa_id); end;''
        using in :kasa_id;
    --PRA_POS_GAS.AZURIRAJ_OZN_SINKRONIZACIJE(:kasa_id);

    :message := ''Podaci su uspješno izmijenjeni!'';

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/automatska_sinkronizacija',
      p_method             => 'PUT',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/automatska_sinkronizacija',
      p_method             => 'PUT',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/automatska_sinkronizacija',
      p_method             => 'PUT',
      p_name               => 'kasa_id',
      p_bind_variable_name => 'kasa_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/automatska_sinkronizacija',
      p_method             => 'PUT',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/automatska_sinkronizacija',
      p_method             => 'PUT',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'kase/{kasa_id}/cjenici',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'kase/{kasa_id}/cjenici',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  25,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
    l_korisnik              VARCHAR2(40);
    l_shema VARCHAR2(40);

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    execute immediate ''begin :cjenici := '' || l_shema || ''PRA_POS_GAS.cjenici(:kasa_id); end;''
        using out :cjenici, in :kasa_id;

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/cjenici',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/cjenici',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/cjenici',
      p_method             => 'GET',
      p_name               => 'cjenici',
      p_bind_variable_name => 'cjenici',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/cjenici',
      p_method             => 'GET',
      p_name               => 'kasa_id',
      p_bind_variable_name => 'kasa_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/cjenici',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/cjenici',
      p_method             => 'GET',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'kase/{kasa_id}/cjenici/{cjenik_id}/vplacanja',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'kase/{kasa_id}/cjenici/{cjenik_id}/vplacanja',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  25,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
    l_korisnik              VARCHAR2(40);
    l_shema VARCHAR2(40);

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    execute immediate ''begin :vplacanja := '' || l_shema || ''PRA_POS_GAS.VPLACANJA(:kasa_id, :cjenik_id); end;''
        using out :vplacanja, in :kasa_id, in :cjenik_id;

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/cjenici/{cjenik_id}/vplacanja',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/cjenici/{cjenik_id}/vplacanja',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/cjenici/{cjenik_id}/vplacanja',
      p_method             => 'GET',
      p_name               => 'cjenik_id',
      p_bind_variable_name => 'cjenik_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/cjenici/{cjenik_id}/vplacanja',
      p_method             => 'GET',
      p_name               => 'kasa_id',
      p_bind_variable_name => 'kasa_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/cjenici/{cjenik_id}/vplacanja',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/cjenici/{cjenik_id}/vplacanja',
      p_method             => 'GET',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/cjenici/{cjenik_id}/vplacanja',
      p_method             => 'GET',
      p_name               => 'vrste_placanja',
      p_bind_variable_name => 'vplacanja',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'kase/{kasa_id}/konobari',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'kase/{kasa_id}/konobari',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  25,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
    l_korisnik              VARCHAR2(40);
    l_shema VARCHAR2(40);

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    execute immediate ''begin :konobari := '' || l_shema || ''PRA_POS_GAS.konobari(:kasa_id); end;''
        using out :konobari, in :kasa_id;

    --:konobari := PRA_POS_GAS.konobari(:kasa_id);

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/konobari',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/konobari',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/konobari',
      p_method             => 'GET',
      p_name               => 'kasa_id',
      p_bind_variable_name => 'kasa_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/konobari',
      p_method             => 'GET',
      p_name               => 'konobari',
      p_bind_variable_name => 'konobari',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/konobari',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/konobari',
      p_method             => 'GET',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'kase/{kasa_id}/konobari/{konobar_id}/cjenici',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'kase/{kasa_id}/konobari/{konobar_id}/cjenici',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  25,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
    l_korisnik              VARCHAR2(40);
    l_shema VARCHAR2(40);

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    execute immediate ''begin :cjenici := '' || l_shema || ''PRA_POS_GAS.CJENICI_KONOBARA(:konobar_id, :kasa_id); end;''
        using out :cjenici, in :konobar_id, in :kasa_id;

    --:cjenici := PRA_POS_GAS.CJENICI_KONOBARA(:konobar_id, :kasa_id);

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/konobari/{konobar_id}/cjenici',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/konobari/{konobar_id}/cjenici',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/konobari/{konobar_id}/cjenici',
      p_method             => 'GET',
      p_name               => 'cjenici',
      p_bind_variable_name => 'cjenici',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/konobari/{konobar_id}/cjenici',
      p_method             => 'GET',
      p_name               => 'kasa_id',
      p_bind_variable_name => 'kasa_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/konobari/{konobar_id}/cjenici',
      p_method             => 'GET',
      p_name               => 'konobar_id',
      p_bind_variable_name => 'konobar_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/konobari/{konobar_id}/cjenici',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/konobari/{konobar_id}/cjenici',
      p_method             => 'GET',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'kase/{kasa_id}/konobari/{konobar_id}/dozvole',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'kase/{kasa_id}/konobari/{konobar_id}/dozvole',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  25,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
    l_korisnik              VARCHAR2(40);
    l_shema VARCHAR2(40);

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    execute immediate ''begin :dozvole := '' || l_shema || ''PRA_POS_GAS.dozvole(:kasa_id, :konobar_id); end;''
        using out :dozvole, in :kasa_id, in :konobar_id;

    --:dozvole := PRA_POS_GAS.dozvole(:kasa_id, :konobar_id);

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/konobari/{konobar_id}/dozvole',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/konobari/{konobar_id}/dozvole',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/konobari/{konobar_id}/dozvole',
      p_method             => 'GET',
      p_name               => 'dozvole',
      p_bind_variable_name => 'dozvole',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/konobari/{konobar_id}/dozvole',
      p_method             => 'GET',
      p_name               => 'kasa_id',
      p_bind_variable_name => 'kasa_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/konobari/{konobar_id}/dozvole',
      p_method             => 'GET',
      p_name               => 'konobar_id',
      p_bind_variable_name => 'konobar_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/konobari/{konobar_id}/dozvole',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/konobari/{konobar_id}/dozvole',
      p_method             => 'GET',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'kase/{kasa_id}/mjesta_troska',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'kase/{kasa_id}/mjesta_troska',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  25,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
    l_korisnik              VARCHAR2(40);
    l_shema VARCHAR2(40);

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    execute immediate ''begin :mjesta_troska := '' || l_shema || ''PRA_POS_GAS.MJESTA_TROSKA(:kasa_id); end;''
        using out :mjesta_troska, in :kasa_id;

    --:mjesta_troska := PRA_POS_GAS.MJESTA_TROSKA(:kasa_id);

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/mjesta_troska',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/mjesta_troska',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/mjesta_troska',
      p_method             => 'GET',
      p_name               => 'kasa_id',
      p_bind_variable_name => 'kasa_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/mjesta_troska',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/mjesta_troska',
      p_method             => 'GET',
      p_name               => 'mjesta_troska',
      p_bind_variable_name => 'mjesta_troska',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/mjesta_troska',
      p_method             => 'GET',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'kase/{kasa_id}/nacini_potrosnje_za_popust_gosta',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'kase/{kasa_id}/nacini_potrosnje_za_popust_gosta',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  25,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
    l_korisnik              VARCHAR2(40);
    l_shema VARCHAR2(40);

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    execute immediate ''begin :nacini_potrosnje := '' || l_shema || ''PRA_POS_GAS.NP_LISTA(:kasa_id); end;''
        using out :nacini_potrosnje, in :kasa_id;

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/nacini_potrosnje_za_popust_gosta',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/nacini_potrosnje_za_popust_gosta',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/nacini_potrosnje_za_popust_gosta',
      p_method             => 'GET',
      p_name               => 'kasa_id',
      p_bind_variable_name => 'kasa_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/nacini_potrosnje_za_popust_gosta',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/nacini_potrosnje_za_popust_gosta',
      p_method             => 'GET',
      p_name               => 'nacini_potrosnje',
      p_bind_variable_name => 'nacini_potrosnje',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/nacini_potrosnje_za_popust_gosta',
      p_method             => 'GET',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'kase/{kasa_id}/promet',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'kase/{kasa_id}/promet',
      p_method         => 'PUT',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
    l_korisnik              VARCHAR2(40);
    l_shema VARCHAR2(40);

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    execute immediate ''begin '' || l_shema || ''PRA_POS_GAS.BRISI_PROMET(:kasa_id, :datum_prometa); end;''
        using in :kasa_id, in to_date( :datum_prometa, ''RRRR-MM-dd"T"hh24:mi'' );

    :message := ''Promet obrisan!'';

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/promet',
      p_method             => 'PUT',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/promet',
      p_method             => 'PUT',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/promet',
      p_method             => 'PUT',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'kase/{kasa_id}/promet/postoji',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'kase/{kasa_id}/promet/postoji',
      p_method         => 'POST',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
    l_korisnik              VARCHAR2(40);
    l_shema VARCHAR2(40);

    /**
    * POST BODY PARAMETRI:
    *   datum
    */

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    execute immediate ''begin :promet_postoji := '' || l_shema || ''PRA_POS_GAS.POSTOJI_PROMET(:kasa_id, :datum); end;''
        using out :promet_postoji, in :kasa_id, in TO_DATE( :datum, ''RRRR-MM-dd"T"hh24:mi'' );

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/promet/postoji',
      p_method             => 'POST',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/promet/postoji',
      p_method             => 'POST',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/promet/postoji',
      p_method             => 'POST',
      p_name               => 'kasa_id',
      p_bind_variable_name => 'kasa_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/promet/postoji',
      p_method             => 'POST',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/promet/postoji',
      p_method             => 'POST',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/promet/postoji',
      p_method             => 'POST',
      p_name               => 'promet_postoji',
      p_bind_variable_name => 'promet_postoji',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'kase/{kasa_id}/promet_razdoblje/postoji',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'kase/{kasa_id}/promet_razdoblje/postoji',
      p_method         => 'POST',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
    l_korisnik              VARCHAR2(40);
    l_shema VARCHAR2(40);

    l_datum_od date;
    l_datum_do date;

    /**
    * POST BODY PARAMETRI:
    *   datum_od,
    *   datum_do
    */

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    l_datum_od := to_date(:datum_od, ''RRRR-MM-dd"T"hh24:mi'');
    l_datum_do := to_date(:datum_do, ''RRRR-MM-dd"T"hh24:mi'');

    execute immediate ''begin :promet := '' || l_shema || ''PRA_POS_GAS.PROMET_ZA_RAZDOBLJE(:kasa_id, :datum_od, :datum_do); end;''
        using out :promet, in :kasa_id, in l_datum_od, in l_datum_do;

    /*:promet := pra_pos_gas.PROMET_ZA_RAZDOBLJE(
        :kasa_id, l_datum_od, l_datum_do
    );*/

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/promet_razdoblje/postoji',
      p_method             => 'POST',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/promet_razdoblje/postoji',
      p_method             => 'POST',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/promet_razdoblje/postoji',
      p_method             => 'POST',
      p_name               => 'kasa_id',
      p_bind_variable_name => 'kasa_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/promet_razdoblje/postoji',
      p_method             => 'POST',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/promet_razdoblje/postoji',
      p_method             => 'POST',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/promet_razdoblje/postoji',
      p_method             => 'POST',
      p_name               => 'promet',
      p_bind_variable_name => 'promet',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'kase/{kasa_id}/racuni/suma',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'kase/{kasa_id}/racuni/suma',
      p_method         => 'POST',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
    l_korisnik              VARCHAR2(40);
    l_shema VARCHAR2(40);

    /**
    * POST BODY PARAMETRI:
    *   datum
    */

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    execute immediate ''begin :suma_racuna := '' || l_shema || ''PRA_POS_GAS.SUMA_RACUNA(:datum, :kasa_id); end;''
        using out :suma_racuna, in TO_DATE( :datum, ''RRRR-MM-dd"T"hh24:mi'' ), in :kasa_id;

    /*:suma_racuna := PRA_POS_GAS.SUMA_RACUNA(
        TO_DATE( :datum, ''RRRR-MM-dd"T"hh24:mi'' ), :kasa_id );*/

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/racuni/suma',
      p_method             => 'POST',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/racuni/suma',
      p_method             => 'POST',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/racuni/suma',
      p_method             => 'POST',
      p_name               => 'kasa_id',
      p_bind_variable_name => 'kasa_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/racuni/suma',
      p_method             => 'POST',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/racuni/suma',
      p_method             => 'POST',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/racuni/suma',
      p_method             => 'POST',
      p_name               => 'suma_racuna',
      p_bind_variable_name => 'suma_racuna',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'kase/{kasa_id}/racuni/ukupan_broj',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'kase/{kasa_id}/racuni/ukupan_broj',
      p_method         => 'POST',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
    l_korisnik              VARCHAR2(40);
    l_shema VARCHAR2(40);

    /**
    * POST BODY PARAMETRI:
    *   datum
    */

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    execute immediate ''begin :ukupan_broj_racuna := '' || l_shema || ''PRA_POS_GAS.BROJ_RACUNA(:datum, :kasa_id); end;''
        using out :ukupan_broj_racuna, in TO_DATE( :datum, ''RRRR-MM-dd"T"hh24:mi'' ), in :kasa_id;

    /*:ukupan_broj_racuna := PRA_POS_GAS.BROJ_RACUNA(
        TO_DATE( :datum, ''RRRR-MM-dd"T"hh24:mi'' ), :kasa_id );*/

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/racuni/ukupan_broj',
      p_method             => 'POST',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/racuni/ukupan_broj',
      p_method             => 'POST',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/racuni/ukupan_broj',
      p_method             => 'POST',
      p_name               => 'kasa_id',
      p_bind_variable_name => 'kasa_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/racuni/ukupan_broj',
      p_method             => 'POST',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/racuni/ukupan_broj',
      p_method             => 'POST',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/racuni/ukupan_broj',
      p_method             => 'POST',
      p_name               => 'ukupan_broj_racuna',
      p_bind_variable_name => 'ukupan_broj_racuna',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'konobar',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'konobar',
      p_method         => 'POST',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
    l_korisnik              VARCHAR2(40);
    l_shema VARCHAR2(40);

    /**
    * POST BODY PARAMETRI:
    *   id
    *   sifra
    */

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    execute immediate ''begin :konobar := '' || l_shema || ''PRA_POS_GAS.POSTOJI_KONOBAR(:id, :sifra); end;''
        using out :konobar, in :id, in :sifra;

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'konobar',
      p_method             => 'POST',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'konobar',
      p_method             => 'POST',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'konobar',
      p_method             => 'POST',
      p_name               => 'gas_id',
      p_bind_variable_name => 'konobar',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'konobar',
      p_method             => 'POST',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'konobar',
      p_method             => 'POST',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'maticni_podaci/dozvoljen_prijepis',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'maticni_podaci/dozvoljen_prijepis',
      p_method         => 'POST',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  25,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
    l_korisnik              VARCHAR2(40);
    l_shema VARCHAR2(40);

BEGIN

    IF :api IS NULL OR :api < l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    execute immediate ''begin :dozvoljen_prijepis := '' || l_shema || ''PRA_POS_GAS.DOZVOLJEN_PRIJEPIS(:datum); end;''
        using out :dozvoljen_prijepis, in TO_DATE( :datum, ''RRRR-MM-dd"T"hh24:mi'' );

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'maticni_podaci/dozvoljen_prijepis',
      p_method             => 'POST',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'maticni_podaci/dozvoljen_prijepis',
      p_method             => 'POST',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'maticni_podaci/dozvoljen_prijepis',
      p_method             => 'POST',
      p_name               => 'dozvoljen_prijepis',
      p_bind_variable_name => 'dozvoljen_prijepis',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'maticni_podaci/dozvoljen_prijepis',
      p_method             => 'POST',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'maticni_podaci/dozvoljen_prijepis',
      p_method             => 'POST',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'mjesto_troska',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'mjesto_troska',
      p_method         => 'POST',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
    l_korisnik              VARCHAR2(40);
    l_shema VARCHAR2(40);

    /**
    * POST BODY PARAMETRI:
    *   id
    *   sifra
    */

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    execute immediate ''begin :mjesto_troska := '' || l_shema || ''PRA_POS_GAS.POSTOJI_MT(:id, :sifra); end;''
        using out :mjesto_troska, in :id, in :sifra;

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'mjesto_troska',
      p_method             => 'POST',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'mjesto_troska',
      p_method             => 'POST',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'mjesto_troska',
      p_method             => 'POST',
      p_name               => 'gas_id',
      p_bind_variable_name => 'mjesto_troska',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'mjesto_troska',
      p_method             => 'POST',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'mjesto_troska',
      p_method             => 'POST',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'porezna_isporuka',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'porezna_isporuka',
      p_method         => 'POST',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
    l_korisnik              VARCHAR2(40);
    l_shema VARCHAR2(40);

    /**
    * POST BODY PARAMETRI:
    *   id
    *   sifra
    */

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    execute immediate ''begin :porezna_isporuka := '' || l_shema || ''PRA_POS_GAS.POSTOJI_PISPORUKA(:id, :sifra); end;''
        using out :porezna_isporuka, in :id, in :sifra;

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'porezna_isporuka',
      p_method             => 'POST',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'porezna_isporuka',
      p_method             => 'POST',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'porezna_isporuka',
      p_method             => 'POST',
      p_name               => 'gas_id',
      p_bind_variable_name => 'porezna_isporuka',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'porezna_isporuka',
      p_method             => 'POST',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'porezna_isporuka',
      p_method             => 'POST',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'posso/kase/{kasa_id}/narudzbe',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'posso/kase/{kasa_id}/narudzbe',
      p_method         => 'POST',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
    l_korisnik              VARCHAR2(40);
    l_shema VARCHAR2(40);

    /**
    * POST BODY PARAMETRI:
    *   datum
    */

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    execute immediate ''begin :narudzbe_gosta := '' || l_shema || ''PRA_POS_GAS.R_POSSO_DOHVATI_ZAGLAVLJA(:kasa_id, :datum); end;''
        using out :narudzbe_gosta, in :kasa_id, in TO_DATE( :datum, ''RRRR-MM-dd"T"hh24:mi'' );

    /*:narudzbe_gosta := PRA_POS_GAS.R_POSSO_DOHVATI_ZAGLAVLJA( :kasa_id,
        TO_DATE( :datum, ''RRRR-MM-dd"T"hh24:mi'' ) );*/

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'posso/kase/{kasa_id}/narudzbe',
      p_method             => 'POST',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'posso/kase/{kasa_id}/narudzbe',
      p_method             => 'POST',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'posso/kase/{kasa_id}/narudzbe',
      p_method             => 'POST',
      p_name               => 'kasa_id',
      p_bind_variable_name => 'kasa_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'posso/kase/{kasa_id}/narudzbe',
      p_method             => 'POST',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'posso/kase/{kasa_id}/narudzbe',
      p_method             => 'POST',
      p_name               => 'narudzbe_gosta',
      p_bind_variable_name => 'narudzbe_gosta',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'posso/kase/{kasa_id}/narudzbe',
      p_method             => 'POST',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'posso/narudzbe/{id}',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'posso/narudzbe/{id}',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
    l_korisnik              VARCHAR2(40);
    l_shema VARCHAR2(40);

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    execute immediate ''begin :narudzba := '' || l_shema || ''PRA_POS_GAS.R_POSSO_DOHVATI_PO_ID(:id); end;''
        using out :narudzba, in :id;

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'posso/narudzbe/{id}',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'posso/narudzbe/{id}',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'posso/narudzbe/{id}',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'posso/narudzbe/{id}',
      p_method             => 'GET',
      p_name               => 'narudzba',
      p_bind_variable_name => 'narudzba',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'posso/narudzbe/{id}',
      p_method             => 'GET',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'posso/narudzbe/{id}/stavke',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'posso/narudzbe/{id}/stavke',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
l_korisnik              VARCHAR2(40);
l_shema VARCHAR2(40);

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    execute immediate ''begin :stavke := '' || l_shema || ''PRA_POS_GAS.R_POSSO_DOHVATI_STAVKE(:id); end;''
        using out :stavke, in :id;

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'posso/narudzbe/{id}/stavke',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'posso/narudzbe/{id}/stavke',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'posso/narudzbe/{id}/stavke',
      p_method             => 'GET',
      p_name               => 'id',
      p_bind_variable_name => 'id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'posso/narudzbe/{id}/stavke',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'posso/narudzbe/{id}/stavke',
      p_method             => 'GET',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'posso/narudzbe/{id}/stavke',
      p_method             => 'GET',
      p_name               => 'stavke',
      p_bind_variable_name => 'stavke',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'racuni',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'racuni',
      p_method         => 'POST',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE

    -- zaglavlje
    l_GODINA VARCHAR2(5);
    l_KASE_ID NUMBER;
    l_RBR VARCHAR2(50);
    l_DATUM VARCHAR2(30);
    l_KON_ID NUMBER;
    l_NAC_ID NUMBER;
    l_VPLA_ID NUMBER;
    l_POPUST NUMBER;
    l_OPIS VARCHAR2(100);
    l_VRIJEME VARCHAR2(5);
    l_OJ_ID NUMBER;
    l_SJ_ID NUMBER;
    l_AGE_ID NUMBER;
    l_BR_GOSTIJU NUMBER;
    l_PKAADR_ID NUMBER;
    l_VPDOG_ID NUMBER;
    l_GODINA_STO VARCHAR2(4);
    l_RBR_STO VARCHAR2(10);
    l_JIR VARCHAR2(40);
    l_ZASTITNI_KOD VARCHAR2(40);
    l_PARAGON VARCHAR2(500);
    l_PARAGON_SET VARCHAR2(50);
    l_PARAGON_SERIJA VARCHAR2(50);
    l_BR_LOY_KARTICE VARCHAR2(50);
    l_BR_KARTICE VARCHAR2(50);
    L_BR_STOLA NUMBER;
    L_IZNOS_PLACANJA NUMBER;
    L_IZNOS_PLACANJA_2 NUMBER;
    L_VPLA_2_ID NUMBER;

    -- stavka
    l_rbr_stavke NUMBER;
    l_pro_sifra_stavke VARCHAR2(50);
    l_sifgr_id_stavke NUMBER;
    l_gpor_id_stavke NUMBER;
    l_mt_id_stavke NUMBER;
    l_kolicina_stavke NUMBER;
    l_cijena_stavke NUMBER;
    l_pdv_stavke NUMBER;
    l_ppot_stavke NUMBER;
    l_vpispz_id_stavke NUMBER;
    l_popust_stavke NUMBER;
    l_iznos_popust_stavke NUMBER;
    l_matkalk_id_stavke NUMBER;
    l_pro_id_stavke NUMBER;
    l_iznos_pdv_stavke NUMBER;
    l_iznos_ppot_stavke NUMBER;
    l_iznos_stavke NUMBER;
    l_iznos_pnaknade_stavke NUMBER;
    l_zmpdje_id_stavke NUMBER;


    l_insert_header varchar2(500);


    l_default_lang_ctx NUMBER;
    l_blob BLOB;
    l_clob clob;
    l_warning   NUMBER;
    l_offset NUMBER :=1;
    l_amount NUMBER;
    l_test VARCHAR2(50);

    l_broj_racuna NUMBER;
    l_broj_stavaka number;

    l_racun VARCHAR2(500);
    l_stavka VARCHAR2(500);

    l_rezultat varchar2 (500);

    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
    l_korisnik              VARCHAR2(40);
    l_shema VARCHAR2(40);

    l_values apex_json.t_values;

    /**
    * POST BODY PARAMETRI:
    *{
        "racuni": [
		{
			"godina": "2017",
			"kase_id": 5067,
			"rbr": "000009",
			"datum": "08.11.27",
			"kon_id": 7042,
			"nac_id": 474,
			"vpla_id": 1,
			"popust": 0,
			"opis": "TURISTIČKA ZAJEDNICA DONJA STUBICA",
			"vrijeme": "0000",
			"oj_id": 5064,
			"sj_id": 93,
			"age_id": 311,
			"br_gostiju": 1,
			"pkaadr_ozn": null,
			"vpdog_id": null,
			"GODINA_STO": null,
			"RBR_STO": null,
			"jir": null,
			"zastitni_kod": null,
			"paragon": null,
			"paragon_set": null,
			"paragon_serija": null,
			"BR_LOY_KARTICE": null,
			"BR_KARTICE": null,
            "iznos_placanja": 12,
            "iznos_placanja_2": null,
            "vrsta_placanja_2_id": null,
			"stavke": [
				{
					"rbr_stavke": 1,
					"pro_sifra": "2214",
					"sifgr_id": null,
					"gpor_id": 153,
					"mt_id": 5064,
					"kolicina": 2,
					"cijena": 22.00,
					"pdv": 25,
					"ppot": 3,
					"vpispz": null,
					"popust": 0,
					"iznos_popust": 0,
					"matkalk_id": null,
					"pro_id": 828,
					"iznos_pdv": 10.00,
					"iznos_ppot": 6.00,
					"iznos": 30.00,
					"iznos_pnaknade": 0,
					"iznos_marze": 0,
					"iznos_pdv_marze": 0,
					"stopa_pdv_marze": 0,
					"zmpdje_id": null
				}
                ]
            }
            ]
        }
        */

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    l_blob := :body;
    l_default_lang_ctx := dbms_lob.default_lang_ctx;

    IF DBMS_LOB.getlength(l_blob) = 0 THEN
        RETURN;
    ELSE
        l_amount := DBMS_LOB.GETLENGTH(l_blob);
        DBMS_LOB.OPEN(l_blob, DBMS_LOB.LOB_READONLY);

        DBMS_LOB.CREATETEMPORARY(l_clob, TRUE);
        DBMS_LOB.CONVERTTOCLOB(
        dest_lob     => l_clob,
        src_blob     => l_blob,
        amount       => l_amount,
        dest_offset  => l_offset,
        src_offset   => l_offset,
        blob_csid    => nls_charset_id(''UTF8''),
        lang_context => l_default_lang_ctx,
        warning      => l_warning);

        DBMS_LOB.CLOSE(l_blob);
    END IF;

    apex_json.parse(l_values, l_clob);


    l_broj_racuna := apex_json.get_count(p_path => ''.'', p_values => l_values);

    FOR racun IN 1 .. nvl(l_broj_racuna,-1) LOOP

        l_GODINA := apex_json.get_varchar2(p_path => ''[%d].godina'', p0 => racun, p_values => l_values);
        l_KASE_ID := apex_json.get_number(p_path => ''[%d].kasa_id'', p0 => racun, p_values => l_values);
        l_RBR := apex_json.get_varchar2(p_path => ''[%d].rbr'', p0 => racun, p_values => l_values);
        l_DATUM := apex_json.get_varchar2(p_path => ''[%d].datum'', p0 => racun, p_values => l_values);
        l_KON_ID := apex_json.get_number(p_path => ''[%d].kon_id'', p0 => racun, p_values => l_values);
        l_NAC_ID := apex_json.get_number(p_path => ''[%d].nac_id'', p0 => racun, p_values => l_values);
        l_VPLA_ID := apex_json.get_number(p_path => ''[%d].vpla_id'', p0 => racun, p_values => l_values);
        l_POPUST := apex_json.get_number(p_path => ''[%d].popust'', p0 => racun, p_values => l_values);
        l_OPIS := apex_json.get_varchar2(p_path => ''[%d].opis'', p0 => racun, p_values => l_values);
        l_VRIJEME := apex_json.get_varchar2(p_path => ''[%d].vrijeme'', p0 => racun, p_values => l_values);
        l_OJ_ID := apex_json.get_number(p_path => ''[%d].oj_id'', p0 => racun, p_values => l_values);
        l_SJ_ID := apex_json.get_number(p_path => ''[%d].sj_id'', p0 => racun, p_values => l_values);
        l_AGE_ID := apex_json.get_number(p_path => ''[%d].age_id'', p0 => racun, p_values => l_values);
        l_BR_GOSTIJU := apex_json.get_number(p_path => ''[%d].broj_gastro_gostiju'', p0 => racun, p_values => l_values);
        l_PKAADR_ID := apex_json.get_number(p_path => ''[%d].pkaadr_ozn'', p0 => racun, p_values => l_values);
        l_VPDOG_ID := apex_json.get_number(p_path => ''[%d].vpdog_id'', p0 => racun, p_values => l_values);
        l_GODINA_STO := apex_json.get_varchar2(p_path => ''[%d].godina_sto'', p0 => racun, p_values => l_values);
        l_RBR_STO := apex_json.get_varchar2(p_path => ''[%d].rbr_sto'', p0 => racun, p_values => l_values);
        l_JIR := apex_json.get_varchar2(p_path => ''[%d].jir'', p0 => racun, p_values => l_values);
        l_ZASTITNI_KOD := apex_json.get_varchar2(p_path => ''[%d].zastitni_kod'', p0 => racun, p_values => l_values);
        l_PARAGON := apex_json.get_varchar2(p_path => ''[%d].paragon'', p0 => racun, p_values => l_values);
        l_PARAGON_SET := apex_json.get_varchar2(p_path => ''[%d].paragon_set'', p0 => racun, p_values => l_values);
        l_PARAGON_SERIJA := apex_json.get_varchar2(p_path => ''[%d].paragon_serija'', p0 => racun, p_values => l_values);
        l_BR_LOY_KARTICE := apex_json.get_varchar2(p_path => ''[%d].broj_loy_kartice'', p0 => racun, p_values => l_values);
        l_BR_KARTICE := apex_json.get_varchar2(p_path => ''[%d].broj_kartice'', p0 => racun, p_values => l_values);
        L_BR_STOLA := apex_json.get_number(p_path => ''[%d].br_stola'', p0 => racun, p_values => l_values);
        L_IZNOS_PLACANJA := apex_json.get_number(p_path => ''[%d].iznos_placanja'', p0 => racun, p_values => l_values);
        L_IZNOS_PLACANJA_2 := apex_json.get_number(p_path => ''[%d].iznos_placanja_2'', p0 => racun, p_values => l_values);
        L_VPLA_2_ID := apex_json.get_number(p_path => ''[%d].vrsta_placanja_2_id'', p0 => racun, p_values => l_values);

        execute immediate ''begin '' || l_shema || ''PRA_POS_GAS.UCITAJ_RNKASE(
                :GODINA,
                :KASE_ID ,
                :RBR ,
                :DATUM,
                :KON_ID ,
                :NAC_ID ,
                :VPLA_ID ,
                :POPUST ,
                :OPIS ,
                :VRIJEME ,
                :OJ_ID ,
                :SJ_ID ,
                :AGE_ID ,
                :BR_GOSTIJU ,
                :PKAADR_ID ,
                :VPDOG_ID ,
                :GODINA_STO ,
                :RBR_STO ,
                :JIR ,
                :ZASTITNI_KOD ,
                :PARAGON ,
                :PARAGON_SET ,
                :PARAGON_SERIJA ,
                :BR_LOY_KARTICE ,
                :BR_KARTICE ,
                :BR_STOLA,
                :VPLA_2_ID,
                :IZNOS_PLACANJA,
                :IZNOS_PLACANJA_2);
            end;''
            using
                in L_GODINA,
                in L_KASE_ID ,
                in L_RBR ,
                in to_date(l_DATUM, ''RRRR-MM-dd"T"hh24:mi'') ,
                in L_KON_ID ,
                in L_NAC_ID ,
                in L_VPLA_ID ,
                in L_POPUST ,
                in L_OPIS ,
                in L_VRIJEME ,
                in L_OJ_ID ,
                in L_SJ_ID ,
                in L_AGE_ID ,
                in L_BR_GOSTIJU ,
                in L_PKAADR_ID ,
                in L_VPDOG_ID ,
                in L_GODINA_STO ,
                in L_RBR_STO ,
                in L_JIR ,
                in L_ZASTITNI_KOD ,
                in L_PARAGON ,
                in L_PARAGON_SET ,
                in L_PARAGON_SERIJA ,
                in L_BR_LOY_KARTICE ,
                in L_BR_KARTICE ,
                in L_BR_STOLA,
                in L_VPLA_2_ID,
                in L_IZNOS_PLACANJA,
                in L_IZNOS_PLACANJA_2;


        /*pra_pos_gas.UCITAJ_RNKASE(  l_GODINA,
                                    l_KASE_ID ,
                                    l_RBR ,
                                    to_date(l_DATUM, ''RRRR-MM-dd"T"hh24:mi'') ,
                                    l_KON_ID ,
                                    l_NAC_ID ,
                                    l_VPLA_ID ,
                                    l_POPUST ,
                                    l_OPIS ,
                                    l_VRIJEME ,
                                    l_OJ_ID ,
                                    l_SJ_ID ,
                                    l_AGE_ID ,
                                    l_BR_GOSTIJU ,
                                    l_PKAADR_ID ,
                                    l_VPDOG_ID ,
                                    l_GODINA_STO ,
                                    l_RBR_STO ,
                                    l_JIR ,
                                    l_ZASTITNI_KOD ,
                                    l_PARAGON ,
                                    l_PARAGON_SET ,
                                    l_PARAGON_SERIJA ,
                                    l_BR_LOY_KARTICE ,
                                    l_BR_KARTICE ,
                                    L_BR_STOLA,
                                    L_VPLA_2_ID,
                                    L_IZNOS_PLACANJA,
                                    L_IZNOS_PLACANJA_2);*/


        l_broj_stavaka := apex_json.get_count(p_path => ''[%d].stavke'', p0 => racun, p_values => l_values);

        FOR stavka IN 1 .. nvl(l_broj_stavaka,-1) LOOP

            l_rbr_stavke := apex_json.get_number(p_path => ''[%d].stavke[%d].rbr_stavke'', p0 => racun, p1 => stavka, p_values => l_values);
            l_pro_sifra_stavke := apex_json.get_VARCHAR2(p_path => ''[%d].stavke[%d].pro_sifra'', p0 => racun, p1 => stavka, p_values => l_values);
            l_sifgr_id_stavke := apex_json.get_number(p_path => ''[%d].stavke[%d].sifgr_id'', p0 => racun, p1 => stavka, p_values => l_values);
            l_gpor_id_stavke := apex_json.get_number(p_path => ''[%d].stavke[%d].gpor_id'', p0 => racun, p1 => stavka, p_values => l_values);
            l_mt_id_stavke := apex_json.get_number(p_path => ''[%d].stavke[%d].mt_id'', p0 => racun, p1 => stavka, p_values => l_values);
            l_kolicina_stavke := apex_json.get_number(p_path => ''[%d].stavke[%d].kolicina'', p0 => racun, p1 => stavka, p_values => l_values);
            l_cijena_stavke := apex_json.get_number(p_path => ''[%d].stavke[%d].cijena'', p0 => racun, p1 => stavka, p_values => l_values);
            l_pdv_stavke := apex_json.get_number(p_path => ''[%d].stavke[%d].pdv'', p0 => racun, p1 => stavka, p_values => l_values);
            l_ppot_stavke := apex_json.get_number(p_path => ''[%d].stavke[%d].ppot'', p0 => racun, p1 => stavka, p_values => l_values);
            l_vpispz_id_stavke := apex_json.get_number(p_path => ''[%d].stavke[%d].vpispz'', p0 => racun, p1 => stavka, p_values => l_values);
            l_popust_stavke := apex_json.get_number(p_path => ''[%d].stavke[%d].popust'', p0 => racun, p1 => stavka, p_values => l_values);
            l_iznos_popust_stavke := apex_json.get_number(p_path => ''[%d].stavke[%d].iznos_popust'', p0 => racun, p1 => stavka, p_values => l_values);
            l_matkalk_id_stavke := apex_json.get_number(p_path => ''[%d].stavke[%d].matkalk_id'', p0 => racun, p1 => stavka, p_values => l_values);
            l_pro_id_stavke := apex_json.get_number(p_path => ''[%d].stavke[%d].pro_id'', p0 => racun, p1 => stavka, p_values => l_values);
            l_iznos_pdv_stavke := apex_json.get_number(p_path => ''[%d].stavke[%d].iznos_pdv'', p0 => racun, p1 => stavka, p_values => l_values);
            l_iznos_ppot_stavke := apex_json.get_number(p_path => ''[%d].stavke[%d].iznos_ppot'', p0 => racun, p1 => stavka, p_values => l_values);
            l_iznos_stavke := apex_json.get_number(p_path => ''[%d].stavke[%d].iznos'', p0 => racun, p1 => stavka, p_values => l_values);
            l_iznos_pnaknade_stavke := apex_json.get_number(p_path => ''[%d].stavke[%d].iznos_pnaknade'', p0 => racun, p1 => stavka, p_values => l_values);
            l_zmpdje_id_stavke := apex_json.get_number(p_path => ''[%d].stavke[%d].zmpdje_id'', p0 => racun, p1 => stavka, p_values => l_values);

            execute immediate ''begin '' || l_shema || ''PRA_POS_GAS.ucitaj_rnkase_pro(
                    :GODINA,
                    :KASE_ID,
                    :RBR,
                    :rbr_stavke,
                    :pro_sifra_stavke,
                    :sifgr_id_stavke,
                    :gpor_id_stavke,
                    :mt_id_stavke,
                    :kolicina_stavke,
                    :cijena_stavke,
                    :pdv_stavke,
                    :ppot_stavke,
                    :vpispz_id_stavke,
                    :popust_stavke,
                    :matkalk_id_stavke,
                    :pro_id_stavke,
                    :iznos_stavke,
                    :iznos_popust_stavke,
                    :iznos_pdv_stavke,
                    :iznos_ppot_stavke,
                    :iznos_pnaknade_stavke,
                    :zmpdje_id_stavke);
                end;''
                using
                    in L_GODINA,
                    in L_KASE_ID,
                    in L_RBR,
                    in L_rbr_stavke,
                    in L_pro_sifra_stavke,
                    in L_sifgr_id_stavke,
                    in L_gpor_id_stavke,
                    in L_mt_id_stavke,
                    in L_kolicina_stavke,
                    in L_cijena_stavke,
                    in L_pdv_stavke,
                    in L_ppot_stavke,
                    in L_vpispz_id_stavke,
                    in L_popust_stavke,
                    in L_matkalk_id_stavke,
                    in L_pro_id_stavke,
                    in L_iznos_stavke,
                    in L_iznos_popust_stavke,
                    in L_iznos_pdv_stavke,
                    in L_iznos_ppot_stavke,
                    in L_iznos_pnaknade_stavke,
                    in L_zmpdje_id_stavke;




            /*pra_pos_gas.ucitaj_rnkase_pro(l_GODINA,
                                        l_KASE_ID,
                                        l_RBR,
                                        l_rbr_stavke,
                                        l_pro_sifra_stavke,
                                        l_sifgr_id_stavke,
                                        l_gpor_id_stavke,
                                        l_mt_id_stavke,
                                        l_kolicina_stavke,
                                        l_cijena_stavke,
                                        l_pdv_stavke,
                                        l_ppot_stavke,
                                        l_vpispz_id_stavke,
                                        l_popust_stavke,
                                        l_matkalk_id_stavke,
                                        l_pro_id_stavke,
                                        l_iznos_stavke,
                                        l_iznos_popust_stavke,
                                        l_iznos_pdv_stavke,
                                        l_iznos_ppot_stavke,
                                        l_iznos_pnaknade_stavke,
                                        l_zmpdje_id_stavke);*/

        end loop;

    END LOOP;

    :message := ''Podaci su uspješno upisani '' || l_broj_racuna;

    :status := 201;

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERS THEN
            rollback;
            :status := 500;
            :message := SQLERRM;
            :error_code := abs(SQLCODE);

end;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'racuni',
      p_method             => 'POST',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'racuni',
      p_method             => 'POST',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'racuni',
      p_method             => 'POST',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'racuni',
      p_method             => 'POST',
      p_name               => 'ora_error_code',
      p_bind_variable_name => 'error_code',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'racuni',
      p_method             => 'POST',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'sustavi/{sustav_sifra}/parametri/{parametar_sifra}',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'sustavi/{sustav_sifra}/parametri/{parametar_sifra}',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  25,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
    l_korisnik              VARCHAR2(40);
    l_shema VARCHAR2(40);

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    execute immediate ''begin :vrijednost_parametra := '' || l_shema || ''PRA_POS_GAS.ZMPPAR_VRIJEDNOST(:sustav_sifra, :parametar_sifra); end;''
        using out :vrijednost_parametra, in :sustav_sifra, in :parametar_sifra;

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'sustavi/{sustav_sifra}/parametri/{parametar_sifra}',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'sustavi/{sustav_sifra}/parametri/{parametar_sifra}',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'sustavi/{sustav_sifra}/parametri/{parametar_sifra}',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'sustavi/{sustav_sifra}/parametri/{parametar_sifra}',
      p_method             => 'GET',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'sustavi/{sustav_sifra}/parametri/{parametar_sifra}',
      p_method             => 'GET',
      p_name               => 'parametar_sifra',
      p_bind_variable_name => 'parametar_sifra',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'sustavi/{sustav_sifra}/parametri/{parametar_sifra}',
      p_method             => 'GET',
      p_name               => 'sustav_sifra',
      p_bind_variable_name => 'sustav_sifra',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'sustavi/{sustav_sifra}/parametri/{parametar_sifra}',
      p_method             => 'GET',
      p_name               => 'vrijednost_parametra_sustava',
      p_bind_variable_name => 'vrijednost_parametra',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'vpdogadjaja',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'vpdogadjaja',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  25,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
    l_korisnik              VARCHAR2(40);
    l_shema VARCHAR2(40);

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    execute immediate ''begin :vpdogadjaja := '' || l_shema || ''PRA_POS_GAS.VPDOGADJAJA; end;''
        using out :vpdogadjaja;

    --:vpdogadjaja := PRA_POS_GAS.VPDOGADJAJA;

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'vpdogadjaja',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'vpdogadjaja',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'vpdogadjaja',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'vpdogadjaja',
      p_method             => 'GET',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'vpdogadjaja',
      p_method             => 'GET',
      p_name               => 'vrsta_poreznih_dogadjaja',
      p_bind_variable_name => 'vpdogadjaja',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'vpisporukap_vpdogadjaja',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'vpisporukap_vpdogadjaja',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  25,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
    l_korisnik              VARCHAR2(40);
    l_shema VARCHAR2(40);

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    execute immediate ''begin :vpisporukap_vpdogadjaja := '' || l_shema || ''PRA_POS_GAS.VPISPORUKAP_VPDOGADJAJA; end;''
        using out :vpisporukap_vpdogadjaja;

    --:vpisporukap_vpdogadjaja := PRA_POS_GAS.VPISPORUKAP_VPDOGADJAJA;

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'vpisporukap_vpdogadjaja',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'vpisporukap_vpdogadjaja',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'vpisporukap_vpdogadjaja',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'vpisporukap_vpdogadjaja',
      p_method             => 'GET',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'vpisporukap_vpdogadjaja',
      p_method             => 'GET',
      p_name               => 'vrste_poreznih_isporuka_dogadjaja',
      p_bind_variable_name => 'vpisporukap_vpdogadjaja',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'vpisporukaz',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'vpisporukaz',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  25,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
    l_korisnik              VARCHAR2(40);
    l_shema VARCHAR2(40);

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    execute immediate ''begin :vpisporukaz := '' || l_shema || ''PRA_POS_GAS.VPISPORUKAZ; end;''
        using out :vpisporukaz;

    --:vpisporukaz := PRA_POS_GAS.VPISPORUKAZ;

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'vpisporukaz',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'vpisporukaz',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'vpisporukaz',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'vpisporukaz',
      p_method             => 'GET',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'vpisporukaz',
      p_method             => 'GET',
      p_name               => 'vrste_porezne_isporuke',
      p_bind_variable_name => 'vpisporukaz',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'vplacanja',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'vplacanja',
      p_method         => 'POST',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
    l_korisnik              VARCHAR2(40);
    l_shema VARCHAR2(40);

    /**
    * POST BODY PARAMETRI:
    *   id
    *   sifra
    */

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    execute immediate ''begin :vrsta_placanja := '' || l_shema || ''PRA_POS_GAS.POSTOJI_VPLACANJA(:id, :sifra); end;''
        using out :vrsta_placanja, in :id, in :sifra;

    --:vrsta_placanja := PRA_POS_GAS.POSTOJI_VPLACANJA(:id, :sifra);

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'vplacanja',
      p_method             => 'POST',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'vplacanja',
      p_method             => 'POST',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'vplacanja',
      p_method             => 'POST',
      p_name               => 'gas_id',
      p_bind_variable_name => 'vrsta_placanja',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'vplacanja',
      p_method             => 'POST',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'vplacanja',
      p_method             => 'POST',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);

  ORDS.DEFINE_MODULE(
      p_module_name    => 'pra_pos_pka',
      p_base_path      => '/pra_pos_pka/',
      p_items_per_page =>  25,
      p_status         => 'PUBLISHED',
      p_comments       => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'adrese',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'adrese',
      p_method         => 'POST',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
    l_korisnik              VARCHAR2(40);
    l_shema VARCHAR2(40);

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    execute immediate ''begin :adrese := '' || l_shema || ''PRA_POS_PKA.ADRESE( :oj_id, :datum, :filter ); end;''
        using out :adrese, in :organizacijska_jedinica_id, in trunc(sysdate), in :filter;

	EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'adrese',
      p_method             => 'POST',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'adrese',
      p_method             => 'POST',
      p_name               => 'adrese',
      p_bind_variable_name => 'adrese',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'adrese',
      p_method             => 'POST',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'adrese',
      p_method             => 'POST',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'adrese',
      p_method             => 'POST',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'agencije',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'agencije',
      p_method         => 'POST',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
    l_korisnik              VARCHAR2(40);
    l_shema VARCHAR2(40);

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    execute immediate ''begin :agencije := '' || l_shema || ''PRA_POS_PKA.AGENCIJE(:filter); end;''
        using out :agencije, in :filter;

	EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'agencije',
      p_method             => 'POST',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'agencije',
      p_method             => 'POST',
      p_name               => 'agencije',
      p_bind_variable_name => 'agencije',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'agencije',
      p_method             => 'POST',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'agencije',
      p_method             => 'POST',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'agencije',
      p_method             => 'POST',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'aranzmani',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'aranzmani',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
    l_korisnik              VARCHAR2(40);
    l_shema VARCHAR2(40);

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    execute immediate ''begin :aranzmani := '' || l_shema || ''PRA_POS_PKA.ARANZMANI; end;''
        using out :aranzmani;

	EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'aranzmani',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'aranzmani',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'aranzmani',
      p_method             => 'GET',
      p_name               => 'aranzmani',
      p_bind_variable_name => 'aranzmani',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'aranzmani',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'aranzmani',
      p_method             => 'GET',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'banke',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'banke',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
l_korisnik              VARCHAR2(40);
l_shema VARCHAR2(40);

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    execute immediate ''begin :banke := '' || l_shema || ''PRA_POS_PKA.BANKE; end;''
        using out :banke;

	EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'banke',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'banke',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'banke',
      p_method             => 'GET',
      p_name               => 'banke',
      p_bind_variable_name => 'banke',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'banke',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'banke',
      p_method             => 'GET',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'banke/{banka_id}/valute',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'banke/{banka_id}/valute',
      p_method         => 'POST',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
    l_korisnik              VARCHAR2(40);
    l_shema VARCHAR2(40);

    /**
    * POST BODY PARAMETRI:
    *   datum
    */

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    execute immediate ''begin :valute := '' || l_shema || ''PRA_POS_PKA.VALUTE(:banka_id, :datum); end;''
        using out :valute, in :banka_id, in TO_DATE( :datum, ''RRRR-MM-dd"T"hh24:mi'' );

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'banke/{banka_id}/valute',
      p_method             => 'POST',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'banke/{banka_id}/valute',
      p_method             => 'POST',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'banke/{banka_id}/valute',
      p_method             => 'POST',
      p_name               => 'banka_id',
      p_bind_variable_name => 'banka_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'banke/{banka_id}/valute',
      p_method             => 'POST',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'banke/{banka_id}/valute',
      p_method             => 'POST',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'banke/{banka_id}/valute',
      p_method             => 'POST',
      p_name               => 'valute',
      p_bind_variable_name => 'valute',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'dozvoljeno_knjizenje',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'dozvoljeno_knjizenje',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  25,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
    l_korisnik              VARCHAR2(40);
    l_shema VARCHAR2(40);

BEGIN

    IF :api IS NULL OR :api < l_ords_api THEN
      RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    execute immediate ''begin :dozvoljeno_knjizenje := '' || l_shema || ''PRA_POS_PKA.PKAPROD_GOTOVA; end;''
        using out :dozvoljeno_knjizenje;

  EXCEPTION
      WHEN api_exception THEN
          :status := 400;
          :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
      WHEN auth_exception THEN
          :status := 401;
          :message := ''invalid username or password'';
      WHEN OTHERs THEN
          rollback;
          :status := 500;
          :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'dozvoljeno_knjizenje',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'dozvoljeno_knjizenje',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'dozvoljeno_knjizenje',
      p_method             => 'GET',
      p_name               => 'dozvoljeno_knjizenje',
      p_bind_variable_name => 'dozvoljeno_knjizenje',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'dozvoljeno_knjizenje',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'dozvoljeno_knjizenje',
      p_method             => 'GET',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'gosti',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'gosti',
      p_method         => 'POST',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
    l_korisnik              VARCHAR2(40);
    l_shema VARCHAR2(40);

    l_datum date;

    /**
    * POST BODY PARAMETRI:
    *   datum
    */

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    execute immediate ''begin :gosti := '' || l_shema || ''PRA_POS_PKA.GOSTI( :smjestajni_objekt_id, :datum, :kasa_id, :filter ); end;''
        using out :gosti,
            in :smjestajni_objekt_id,
            in trunc(to_date( :datum, ''RRRR-MM-dd"T"hh24:mi'' )),
            in :kasa_id,
            in :filter;

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'gosti',
      p_method             => 'POST',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'gosti',
      p_method             => 'POST',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'gosti',
      p_method             => 'POST',
      p_name               => 'gosti',
      p_bind_variable_name => 'gosti',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'gosti',
      p_method             => 'POST',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'gosti',
      p_method             => 'POST',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'kartice/{kartica_id}/limit',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'kartice/{kartica_id}/limit',
      p_method         => 'POST',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
    l_korisnik              VARCHAR2(40);
    l_shema VARCHAR2(40);

    l_kartica_id number;

    /**
    * POST BODY PARAMETRI:
    *   adresa_id
    *   cjenik_id
    *   poslovna_godina
    */

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    if :kartica_id = ''null'' then
        l_kartica_id := null;
    else
        l_kartica_id := to_number(:kartica_id);
    end if;

    execute immediate ''begin '' || l_shema || ''PRA_POS_PKA.PROVJERI_LIMIT( :adresa_id, :kartica_id, :cjenik_id,
        :poslovna_godina, :datum, :oznaka, :iznos ); end;''
        using
            in :adresa_id,
            in :kartica_id,
            in :cjenik_id,
            in :poslovna_godina,
            in :datum,
            out :oznaka,
            out :iznos;

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'kartice/{kartica_id}/limit',
      p_method             => 'POST',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'kartice/{kartica_id}/limit',
      p_method             => 'POST',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'kartice/{kartica_id}/limit',
      p_method             => 'POST',
      p_name               => 'iznos',
      p_bind_variable_name => 'iznos',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'kartice/{kartica_id}/limit',
      p_method             => 'POST',
      p_name               => 'kartica_id',
      p_bind_variable_name => 'kartica_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'kartice/{kartica_id}/limit',
      p_method             => 'POST',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'kartice/{kartica_id}/limit',
      p_method             => 'POST',
      p_name               => 'oznaka',
      p_bind_variable_name => 'oznaka',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'kartice/{kartica_id}/limit',
      p_method             => 'POST',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'loyalty_clanovi/{broj_kartice}',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'loyalty_clanovi/{broj_kartice}',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
l_korisnik              VARCHAR2(40);
l_shema VARCHAR2(40);

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    execute immediate ''begin :loyalty_clanovi := '' || l_shema || ''PRA_POS_PKA.LOY_CLAN( :broj_kartice ); end;''
        using out :loyalty_clanovi, in :broj_kartice;

	--:loyalty_clanovi := PRA_POS_PKA.LOY_CLAN( :broj_kartice );

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'loyalty_clanovi/{broj_kartice}',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'loyalty_clanovi/{broj_kartice}',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'loyalty_clanovi/{broj_kartice}',
      p_method             => 'GET',
      p_name               => 'broj_kartice',
      p_bind_variable_name => 'broj_kartice',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'loyalty_clanovi/{broj_kartice}',
      p_method             => 'GET',
      p_name               => 'loyalty_clanovi',
      p_bind_variable_name => 'loyalty_clanovi',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'loyalty_clanovi/{broj_kartice}',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'loyalty_clanovi/{broj_kartice}',
      p_method             => 'GET',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'organizacijske_jedinice',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'organizacijske_jedinice',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
l_korisnik              VARCHAR2(40);
l_shema VARCHAR2(40);

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;


    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

	execute immediate ''begin :organizacijske_jedinice := '' || l_shema || ''PRA_POS_PKA.ZMPOJR; end;''
        using out :organizacijske_jedinice;

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'organizacijske_jedinice',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'organizacijske_jedinice',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'organizacijske_jedinice',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'organizacijske_jedinice',
      p_method             => 'GET',
      p_name               => 'organizacijske_jedinice',
      p_bind_variable_name => 'organizacijske_jedinice',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'organizacijske_jedinice',
      p_method             => 'GET',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'organizacijske_jedinice/{organizacijska_jedinica_id}/adrese/{adresa_id}',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'organizacijske_jedinice/{organizacijska_jedinica_id}/adrese/{adresa_id}',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
    l_korisnik              VARCHAR2(40);
    l_shema VARCHAR2(40);

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    execute immediate ''begin :adrese := '' || l_shema || ''PRA_POS_PKA.PKAADR_BY_ID( :organizacijska_jedinica_id, :adresa_id ); end;''
        using out :adrese, in :organizacijska_jedinica_id, in :adresa_id;

	EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'organizacijske_jedinice/{organizacijska_jedinica_id}/adrese/{adresa_id}',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'organizacijske_jedinice/{organizacijska_jedinica_id}/adrese/{adresa_id}',
      p_method             => 'GET',
      p_name               => 'adresa_id',
      p_bind_variable_name => 'adresa_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'organizacijske_jedinice/{organizacijska_jedinica_id}/adrese/{adresa_id}',
      p_method             => 'GET',
      p_name               => 'adrese',
      p_bind_variable_name => 'adrese',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'organizacijske_jedinice/{organizacijska_jedinica_id}/adrese/{adresa_id}',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'organizacijske_jedinice/{organizacijska_jedinica_id}/adrese/{adresa_id}',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'organizacijske_jedinice/{organizacijska_jedinica_id}/adrese/{adresa_id}',
      p_method             => 'GET',
      p_name               => 'organizacijska_jedinica_id',
      p_bind_variable_name => 'organizacijska_jedinica_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'organizacijske_jedinice/{organizacijska_jedinica_id}/adrese/{adresa_id}',
      p_method             => 'GET',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'organizacijske_jedinice/{organizacijska_jedinica_id}/racuni',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'organizacijske_jedinice/{organizacijska_jedinica_id}/racuni',
      p_method         => 'POST',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE

    -- racun
    L_ZMPOJR_ID NUMBER;
    L_GMPKAS_ID NUMBER;
    L_VPLA_ID number;
    L_GOSTP_ID NUMBER;
    L_AGEP_ID number;
    L_PKAADRP_ID NUMBER;
    L_GOD_POSLOVNA VARCHAR2(5);
    L_RBR VARCHAR2(20);
    L_DATUM varchar2(20);
    L_IZN_PLACANJA number;
    L_IZN_TECAJA number;
    L_IZN_PPOT NUMBER;
    L_OPIS1 VARCHAR2(50);
    L_OPIS2 varchar2(50);
    L_RECARA_ID number;
    L_VPDOG_ID number;
    L_NAC_ID number;
    L_STOPA_PPOT number;
    L_IZN_OSNOVICE_PPOT number;
    L_PKAKAR_ID number;
    L_GOST_ID number;
    L_AGE_ID number;
    L_PKAADR_ID number;
    L_IZN_POPUSTA NUMBER;
    L_RACUN_ID number;
    L_RBR_STORNO varchar2(20);
    L_GOD_POSLOVNA_STORNO varchar2(5);
    L_VPLA2_ID number;
    L_IZN_PLACANJA2 NUMBER;
    L_PD_ZKI VARCHAR2(40);
    L_PD_JIR VARCHAR2(40);
    L_PD_NAPOMENA VARCHAR2(200);

    L_PKARNK_ID number;


    -- porez
    L_POREZ_IZN_OSNOVICE NUMBER;
    L_POREZ_STOPA_PDV NUMBER;
    L_POREZ_VPISPZ_ID NUMBER;
    L_POREZ_IZN_PDV NUMBER;

    -- isporuka
    L_ISPORUKA_SIFRA VARCHAR2(10);
    L_ISPORUKA_NAZIV VARCHAR2(50);
    L_ISPORUKA_JM VARCHAR2(10);
    L_ISPORUKA_KOLICINA NUMBER;
    L_ISPORUKA_CIJENA number;
    L_ISPORUKA_STOPA_POPUSTA NUMBER;
    L_ISPORUKA_VPISPZ_ID NUMBER;
    L_ISPORUKA_STOPA_PDV NUMBER;
    L_ISPORUKA_IZN_PPOT NUMBER;
    L_ISPORUKA_IZN_PDV number;


    l_default_lang_ctx NUMBER;
    l_blob BLOB;
    l_clob clob;
    l_warning   NUMBER;
    l_offset NUMBER :=1;
    l_amount NUMBER;
    l_values apex_json.t_values;

    l_broj_racuna NUMBER;
    l_broj_stavaka_porez NUMBER;
    l_broj_stavaka_isporuka number;

    l_broj_obrisanih number;


    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
    l_korisnik              VARCHAR2(40);
    l_shema VARCHAR2(40);

BEGIN

    --raise api_exception;

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    l_blob := :body;
    l_default_lang_ctx := dbms_lob.default_lang_ctx;

    IF DBMS_LOB.getlength(l_blob) = 0 THEN
        RETURN;
    ELSE
        l_amount := DBMS_LOB.GETLENGTH(l_blob);
        DBMS_LOB.OPEN(l_blob, DBMS_LOB.LOB_READONLY);

        DBMS_LOB.CREATETEMPORARY(l_clob, TRUE);
        DBMS_LOB.CONVERTTOCLOB(
        dest_lob     => l_clob,
        src_blob     => l_blob,
        amount       => l_amount,
        dest_offset  => l_offset,
        src_offset   => l_offset,
        blob_csid    => nls_charset_id(''UTF8''),
        lang_context => l_default_lang_ctx,
        warning      => l_warning);

        DBMS_LOB.CLOSE(l_blob);
    END IF;

    apex_json.parse(l_values, l_clob);

    L_ZMPOJR_ID := :organizacijska_jedinica_id;

    l_broj_racuna := apex_json.get_count(p_path => ''.'', p_values => l_values);

    FOR racun IN 1 .. nvl(l_broj_racuna,-1) LOOP

        L_RACUN_ID := apex_json.get_varchar2(p_path => ''[%d].racun_id'', p0 => racun, p_values => l_values);

        execute immediate ''begin '' || l_shema || ''pra_pos_pka.DELETE_RACUN(:RACUN_ID, :broj_obrisanih); end;'' using in L_RACUN_ID, out :broj_obrisanih;

        L_GMPKAS_ID := apex_json.get_NUMBER(p_path => ''[%d].kasa_id'', p0 => racun, p_values => l_values);
        L_VPLA_ID := apex_json.get_number(p_path => ''[%d].vrsta_placanja_id'', p0 => racun, p_values => l_values);
        L_GOSTP_ID := apex_json.get_NUMBER(p_path => ''[%d].gostp_id'', p0 => racun, p_values => l_values);
        L_AGEP_ID := apex_json.get_number(p_path => ''[%d].agencijap_id'', p0 => racun, p_values => l_values);
        L_PKAADRP_ID := apex_json.get_number(p_path => ''[%d].adresap_id'', p0 => racun, p_values => l_values);
        L_GOD_POSLOVNA := apex_json.get_varchar2(p_path => ''[%d].poslovna_godina'', p0 => racun, p_values => l_values);
        L_RBR := apex_json.get_varchar2(p_path => ''[%d].rbr'', p0 => racun, p_values => l_values);
        L_DATUM := apex_json.get_varchar2(p_path => ''[%d].datum'', p0 => racun, p_values => l_values);
        L_IZN_PLACANJA := apex_json.get_number(p_path => ''[%d].iznos_placanja'', p0 => racun, p_values => l_values);
        L_IZN_PPOT := apex_json.get_number(p_path => ''[%d].iznos_ppot'', p0 => racun, p_values => l_values);
        L_OPIS1 := apex_json.get_varchar2(p_path => ''[%d].opis_1'', p0 => racun, p_values => l_values);
        L_OPIS2 := apex_json.get_varchar2(p_path => ''[%d].opis_2'', p0 => racun, p_values => l_values);
        L_RECARA_ID := apex_json.get_number(p_path => ''[%d].recara_id'', p0 => racun, p_values => l_values);
        L_VPDOG_ID := apex_json.get_number(p_path => ''[%d].vrsta_poreznog_dogadaja_id'', p0 => racun, p_values => l_values);
        L_NAC_ID := apex_json.get_number(p_path => ''[%d].cjenik_id'', p0 => racun, p_values => l_values);
        L_STOPA_PPOT := apex_json.get_number(p_path => ''[%d].stopa_ppot'', p0 => racun, p_values => l_values);
        L_IZN_OSNOVICE_PPOT := apex_json.get_number(p_path => ''[%d].iznos_osnovice_ppot'', p0 => racun, p_values => l_values);
        L_PKAKAR_ID := apex_json.get_number(p_path => ''[%d].pkakar_id'', p0 => racun, p_values => l_values);
        L_GOST_ID := apex_json.get_number(p_path => ''[%d].gost_id'', p0 => racun, p_values => l_values);
        L_AGE_ID := apex_json.get_number(p_path => ''[%d].agencija_id'', p0 => racun, p_values => l_values);
        L_PKAADR_ID := apex_json.get_number(p_path => ''[%d].adresa_id'', p0 => racun, p_values => l_values);
        L_IZN_POPUSTA := apex_json.get_number(p_path => ''[%d].iznos_popusta'', p0 => racun, p_values => l_values);
        L_RBR_STORNO := apex_json.get_varchar2(p_path => ''[%d].rbr_storno'', p0 => racun, p_values => l_values);
        L_GOD_POSLOVNA_STORNO := apex_json.get_varchar2(p_path => ''[%d].godina_storno'', p0 => racun, p_values => l_values);
        L_VPLA2_ID := apex_json.get_varchar2(p_path => ''[%d].vrsta_placanja_2_id'', p0 => racun, p_values => l_values);
        L_IZN_PLACANJA2 := apex_json.get_varchar2(p_path => ''[%d].iznos_placanja_2'', p0 => racun, p_values => l_values);
        L_PD_ZKI := apex_json.get_varchar2(p_path => ''[%d].pd_zki'', p0 => racun, p_values => l_values);
        L_PD_JIR := apex_json.get_varchar2(p_path => ''[%d].pd_jir'', p0 => racun, p_values => l_values);
        L_PD_NAPOMENA := apex_json.get_varchar2(p_path => ''[%d].pd_napomena'', p0 => racun, p_values => l_values);

        execute immediate ''begin '' || l_shema || ''PRA_POS_PKA.INSERT_RACUN(
            :ZMPOJR_ID,
            :GMPKAS_ID,
            :VPLA_ID,
            :GOSTP_ID,
            :AGEP_ID,
            :PKAADRP_ID,
            :GOD_POSLOVNA,
            :RBR,
            :DATUM,
            :IZN_PLACANJA,
            :IZN_PPOT,
            :OPIS1,
            :OPIS2,
            :RECARA_ID,
            :VPDOG_ID,
            :NAC_ID,
            :STOPA_PPOT,
            :IZN_OSNOVICE_PPOT,
            :PKAKAR_ID,
            :GOST_ID,
            :AGE_ID,
            :PKAADR_ID,
            :IZN_POPUSTA,
            :GOD_POSLOVNA_STORNO,
            :RBR_STORNO,
            :VPLA2_ID,
            :IZN_PLACANJA2,
            :PD_ZKI,
            :PD_JIR,
            :PD_NAPOMENA,
            :PKARNK_ID
        ); end;''
        using
            in L_ZMPOJR_ID,
            in L_GMPKAS_ID,
            in L_VPLA_ID,
            in L_GOSTP_ID,
            in L_AGEP_ID,
            in L_PKAADRP_ID,
            in L_GOD_POSLOVNA,
            in L_RBR,
            in to_date(L_DATUM, ''RRRR-MM-dd"T"hh24:mi''), --2017-11-16T00:00
            in L_IZN_PLACANJA,
            in L_IZN_PPOT,
            in L_OPIS1,
            in L_OPIS2,
            in L_RECARA_ID,
            in L_VPDOG_ID,
            in L_NAC_ID,
            in L_STOPA_PPOT,
            in L_IZN_OSNOVICE_PPOT,
            in L_PKAKAR_ID,
            in L_GOST_ID,
            in L_AGE_ID,
            in L_PKAADR_ID,
            in L_IZN_POPUSTA,
            in L_GOD_POSLOVNA_STORNO,
            in L_RBR_STORNO,
            in L_VPLA2_ID,
            in L_IZN_PLACANJA2,
            in L_PD_ZKI,
            in L_PD_JIR,
            in L_PD_NAPOMENA,
            out L_PKARNK_ID;



        l_broj_stavaka_porez := apex_json.get_count(p_path => ''[%d].porezi'', p0 => racun, p_values => l_values);

        FOR porez IN 1 .. nvl(l_broj_stavaka_porez,-1) LOOP
            L_POREZ_IZN_OSNOVICE := apex_json.get_number(p_path => ''[%d].porezi[%d].iznos_osnovice'', p0 => racun, p1 => porez, p_values => l_values);
            L_POREZ_STOPA_PDV := apex_json.get_number(p_path => ''[%d].porezi[%d].stopa_pdv'', p0 => racun, p1 => porez, p_values => l_values);
            L_POREZ_VPISPZ_ID := apex_json.get_number(p_path => ''[%d].porezi[%d].vrsta_porezne_isporukez_id'', p0 => racun, p1 => porez, p_values => l_values);
            L_POREZ_IZN_PDV := apex_json.get_number(p_path => ''[%d].porezi[%d].iznos_pdv'', p0 => racun, p1 => porez, p_values => l_values);

            execute immediate ''begin '' || l_shema || ''PRA_POS_PKA.INSERT_POREZ(
                :ZMPOJR_ID,
                :PKARNK_ID,
                :POREZ_IZN_OSNOVICE,
                :POREZ_STOPA_PDV,
                :POREZ_VPISPZ_ID,
                :POREZ_IZN_PDV); end;''
            using
                in L_ZMPOJR_ID,
                in L_PKARNK_ID,
                in L_POREZ_IZN_OSNOVICE,
                in L_POREZ_STOPA_PDV,
                in L_POREZ_VPISPZ_ID,
                in L_POREZ_IZN_PDV;

        end loop;

        l_broj_stavaka_isporuka := apex_json.get_count(p_path => ''[%d].pisporuke'', p0 => racun, p_values => l_values);

        FOR pisporuka IN 1 .. nvl(l_broj_stavaka_isporuka,-1) LOOP
            L_ISPORUKA_SIFRA := apex_json.get_varchar2(p_path => ''[%d].pisporuke[%d].sifra'', p0 => racun, p1 => pisporuka, p_values => l_values);
            L_ISPORUKA_NAZIV := apex_json.get_varchar2(p_path => ''[%d].pisporuke[%d].naziv'', p0 => racun, p1 => pisporuka, p_values => l_values);
            L_ISPORUKA_JM := apex_json.get_varchar2(p_path => ''[%d].pisporuke[%d].jm'', p0 => racun, p1 => pisporuka, p_values => l_values);
            L_ISPORUKA_KOLICINA := apex_json.get_number(p_path => ''[%d].pisporuke[%d].kolicina'', p0 => racun, p1 => pisporuka, p_values => l_values);
            L_ISPORUKA_CIJENA := apex_json.get_number(p_path => ''[%d].pisporuke[%d].cijena'', p0 => racun, p1 => pisporuka, p_values => l_values);
            L_ISPORUKA_STOPA_POPUSTA := apex_json.get_number(p_path => ''[%d].pisporuke[%d].stopa_popusta'', p0 => racun, p1 => pisporuka, p_values => l_values);
            L_ISPORUKA_VPISPZ_ID := apex_json.get_number(p_path => ''[%d].pisporuke[%d].vrsta_porezne_isporukez_id'', p0 => racun, p1 => pisporuka, p_values => l_values);
            L_ISPORUKA_STOPA_PDV := apex_json.get_number(p_path => ''[%d].pisporuke[%d].stopa_pdv'', p0 => racun, p1 => pisporuka, p_values => l_values);
            L_ISPORUKA_IZN_PPOT := apex_json.get_NUMBER(p_path => ''[%d].pisporuke[%d].iznos_ppot'', p0 => racun, p1 => pisporuka, p_values => l_values);
            L_ISPORUKA_IZN_PDV := apex_json.get_number(p_path => ''[%d].pisporuke[%d].iznos_pdv'', p0 => racun, p1 => pisporuka, p_values => l_values);

            execute immediate ''begin '' || l_shema || ''PRA_POS_PKA.INSERT_PKARNKISP(
                :ZMPOJR_ID,
                :PKARNK_ID,
                :ISPORUKA_SIFRA,
                :ISPORUKA_NAZIV,
                :ISPORUKA_JM,
                :ISPORUKA_KOLICINA,
                :ISPORUKA_CIJENA,
                :ISPORUKA_STOPA_POPUSTA,
                :ISPORUKA_VPISPZ_ID,
                :ISPORUKA_STOPA_PDV,
                :ISPORUKA_IZN_PPOT,
                :ISPORUKA_IZN_PDV); end;''
            using
                in L_ZMPOJR_ID,
                in L_PKARNK_ID,
                in L_ISPORUKA_SIFRA,
                in L_ISPORUKA_NAZIV,
                in L_ISPORUKA_JM,
                in L_ISPORUKA_KOLICINA,
                in L_ISPORUKA_CIJENA,
                in L_ISPORUKA_STOPA_POPUSTA,
                in L_ISPORUKA_VPISPZ_ID,
                in L_ISPORUKA_STOPA_PDV,
                in L_ISPORUKA_IZN_PPOT,
                in L_ISPORUKA_IZN_PDV;

        end loop;

    end loop;

    rollback;

    :racun_id := L_PKARNK_ID;
    --:broj_obrisanih := l_broj_obrisanih;

    :status := 201;

    EXCEPTION
        WHEN api_exception THEN
            ROLLBACK;
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERS THEN
            rollback;
            :status := 500;
            :message := SQLERRM;
            :error_code := abs(SQLCODE);

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'organizacijske_jedinice/{organizacijska_jedinica_id}/racuni',
      p_method             => 'POST',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'organizacijske_jedinice/{organizacijska_jedinica_id}/racuni',
      p_method             => 'POST',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'organizacijske_jedinice/{organizacijska_jedinica_id}/racuni',
      p_method             => 'POST',
      p_name               => 'broj_obrisanih',
      p_bind_variable_name => 'broj_obrisanih',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'organizacijske_jedinice/{organizacijska_jedinica_id}/racuni',
      p_method             => 'POST',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'organizacijske_jedinice/{organizacijska_jedinica_id}/racuni',
      p_method             => 'POST',
      p_name               => 'ora_error_code',
      p_bind_variable_name => 'error_code',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'organizacijske_jedinice/{organizacijska_jedinica_id}/racuni',
      p_method             => 'POST',
      p_name               => 'organizacijska_jedinica_id',
      p_bind_variable_name => 'organizacijska_jedinica_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'organizacijske_jedinice/{organizacijska_jedinica_id}/racuni',
      p_method             => 'POST',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'organizacijske_jedinice/{organizacijska_jedinica_id}/racuni',
      p_method             => 'POST',
      p_name               => 'racun_id',
      p_bind_variable_name => 'racun_id',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'organizacijske_jedinice/{organizacijska_jedinica_id}/racuni/{racun_id}',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'organizacijske_jedinice/{organizacijska_jedinica_id}/racuni/{racun_id}',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
    l_korisnik              VARCHAR2(40);
    l_shema VARCHAR2(40);

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    execute immediate ''begin '' || l_shema || ''PRA_POS_PKA.VRATI_PKARNK( :organizacijska_jedinica_id, :racun_id, :iznos_placanja, :vrsta_placanja ); end;''
        using in :organizacijska_jedinica_id, in :racun_id, out :iznos_placanja, out :vrsta_placanja;

	--PRA_POS_PKA.VRATI_PKARNK( :organizacijska_jedinica_id,:racun_id, :iznos_placanja, :vrsta_placanja );

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'organizacijske_jedinice/{organizacijska_jedinica_id}/racuni/{racun_id}',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'organizacijske_jedinice/{organizacijska_jedinica_id}/racuni/{racun_id}',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'organizacijske_jedinice/{organizacijska_jedinica_id}/racuni/{racun_id}',
      p_method             => 'GET',
      p_name               => 'iznos_placanja',
      p_bind_variable_name => 'iznos_placanja',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'organizacijske_jedinice/{organizacijska_jedinica_id}/racuni/{racun_id}',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'organizacijske_jedinice/{organizacijska_jedinica_id}/racuni/{racun_id}',
      p_method             => 'GET',
      p_name               => 'organizacijska_jedinica_id',
      p_bind_variable_name => 'organizacijska_jedinica_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'organizacijske_jedinice/{organizacijska_jedinica_id}/racuni/{racun_id}',
      p_method             => 'GET',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'organizacijske_jedinice/{organizacijska_jedinica_id}/racuni/{racun_id}',
      p_method             => 'GET',
      p_name               => 'racun_id',
      p_bind_variable_name => 'racun_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'organizacijske_jedinice/{organizacijska_jedinica_id}/racuni/{racun_id}',
      p_method             => 'GET',
      p_name               => 'vrsta_placanja',
      p_bind_variable_name => 'vrsta_placanja',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'racuni/{racun_id}',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'racuni/{racun_id}',
      p_method         => 'DELETE',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
    l_korisnik              VARCHAR2(40);
    l_shema VARCHAR2(40);

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    execute immediate ''begin '' || l_shema || ''pra_pos_pka.DELETE_RACUN(:racun_id, :broj_obrisanih); end;''
        using in :racun_id, out :broj_obrisanih;

    EXCEPTION
        WHEN api_exception THEN
            rollback;
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'racuni/{racun_id}',
      p_method             => 'DELETE',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'racuni/{racun_id}',
      p_method             => 'DELETE',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'racuni/{racun_id}',
      p_method             => 'DELETE',
      p_name               => 'broj_obrisanih',
      p_bind_variable_name => 'broj_obrisanih',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'racuni/{racun_id}',
      p_method             => 'DELETE',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'racuni/{racun_id}',
      p_method             => 'DELETE',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'racuni/{racun_id}',
      p_method             => 'DELETE',
      p_name               => 'racun_id',
      p_bind_variable_name => 'racun_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'smjestajni_objekti',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'smjestajni_objekti',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
    l_korisnik              VARCHAR2(40);
    l_shema VARCHAR2(40);

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    execute immediate ''begin :smjestajni_objekti := '' || l_shema || ''PRA_POS_PKA.SO; end;''
        using out :smjestajni_objekti;

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti',
      p_method             => 'GET',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti',
      p_method             => 'GET',
      p_name               => 'smjestajni_objekti',
      p_bind_variable_name => 'smjestajni_objekti',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'smjestajni_objekti/{smjestajni_objekt_id}/gosti/{gost_id}',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'smjestajni_objekti/{smjestajni_objekt_id}/gosti/{gost_id}',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
    l_korisnik              VARCHAR2(40);
    l_shema VARCHAR2(40);

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    execute immediate ''begin :gosti := '' || l_shema || ''PRA_POS_PKA.GOST_BY_ID(:smjestajni_objekt_id, :gost_id); end;''
        using out :gosti, in :smjestajni_objekt_id, in :gost_id;

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti/{smjestajni_objekt_id}/gosti/{gost_id}',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti/{smjestajni_objekt_id}/gosti/{gost_id}',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti/{smjestajni_objekt_id}/gosti/{gost_id}',
      p_method             => 'GET',
      p_name               => 'gost_id',
      p_bind_variable_name => 'gost_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti/{smjestajni_objekt_id}/gosti/{gost_id}',
      p_method             => 'GET',
      p_name               => 'gosti',
      p_bind_variable_name => 'gosti',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti/{smjestajni_objekt_id}/gosti/{gost_id}',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti/{smjestajni_objekt_id}/gosti/{gost_id}',
      p_method             => 'GET',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti/{smjestajni_objekt_id}/gosti/{gost_id}',
      p_method             => 'GET',
      p_name               => 'smjestajni_objekt_id',
      p_bind_variable_name => 'smjestajni_objekt_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'smjestajni_objekti/{smjestajni_objekt_id}/kase/{kasa_id}/smjestajne_jedinice',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'smjestajni_objekti/{smjestajni_objekt_id}/kase/{kasa_id}/smjestajne_jedinice',
      p_method         => 'POST',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
    l_korisnik              VARCHAR2(40);
    l_shema VARCHAR2(40);

    l_datum date;

    /**
    * POST BODY PARAMETRI:
    *   datum
    */

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    execute immediate ''begin :smjestajne_jedinice := '' || l_shema || ''PRA_POS_PKA.SJ(:smjestajni_objekt_id, :datum, :kasa_id); end;''
        using out :smjestajne_jedinice, in :smjestajni_objekt_id, in trunc(to_date( :datum, ''RRRR-MM-dd"T"hh24:mi'' )), in :kasa_id;

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti/{smjestajni_objekt_id}/kase/{kasa_id}/smjestajne_jedinice',
      p_method             => 'POST',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti/{smjestajni_objekt_id}/kase/{kasa_id}/smjestajne_jedinice',
      p_method             => 'POST',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti/{smjestajni_objekt_id}/kase/{kasa_id}/smjestajne_jedinice',
      p_method             => 'POST',
      p_name               => 'kasa_id',
      p_bind_variable_name => 'kasa_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti/{smjestajni_objekt_id}/kase/{kasa_id}/smjestajne_jedinice',
      p_method             => 'POST',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti/{smjestajni_objekt_id}/kase/{kasa_id}/smjestajne_jedinice',
      p_method             => 'POST',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti/{smjestajni_objekt_id}/kase/{kasa_id}/smjestajne_jedinice',
      p_method             => 'POST',
      p_name               => 'smjestajne_jedinice',
      p_bind_variable_name => 'smjestajne_jedinice',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti/{smjestajni_objekt_id}/kase/{kasa_id}/smjestajne_jedinice',
      p_method             => 'POST',
      p_name               => 'smjestajni_objekt_id',
      p_bind_variable_name => 'smjestajni_objekt_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'smjestajni_objekti/{smjestajni_objekt_id}/knjiga_racuna',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'smjestajni_objekti/{smjestajni_objekt_id}/knjiga_racuna',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
    l_korisnik              VARCHAR2(40);
    l_shema VARCHAR2(40);

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    execute immediate ''begin :organizacijska_jedinica := '' || l_shema || ''PRA_POS_PKA.SO_OJR_ID(:smjestajni_objekt_id); end;''
        using out :organizacijska_jedinica, in :smjestajni_objekt_id;

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti/{smjestajni_objekt_id}/knjiga_racuna',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti/{smjestajni_objekt_id}/knjiga_racuna',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti/{smjestajni_objekt_id}/knjiga_racuna',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti/{smjestajni_objekt_id}/knjiga_racuna',
      p_method             => 'GET',
      p_name               => 'organizacijska_jedinica',
      p_bind_variable_name => 'organizacijska_jedinica',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti/{smjestajni_objekt_id}/knjiga_racuna',
      p_method             => 'GET',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti/{smjestajni_objekt_id}/knjiga_racuna',
      p_method             => 'GET',
      p_name               => 'smjestajni_objekt_id',
      p_bind_variable_name => 'smjestajni_objekt_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'smjestajni_objekti/{smjestajni_objekt_id}/smjestajne_jedinice/{broj_sj}',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'smjestajni_objekti/{smjestajni_objekt_id}/smjestajne_jedinice/{broj_sj}',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
    l_korisnik              VARCHAR2(40);
    l_shema VARCHAR2(40);

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    execute immediate ''begin :smjestajne_jedinice := '' || l_shema || ''PRA_POS_PKA.SJ_ZA_BROJ(:smjestajni_objekt_id, :broj_sj); end;''
        using out :smjestajne_jedinice, in :smjestajni_objekt_id, in :broj_sj;

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti/{smjestajni_objekt_id}/smjestajne_jedinice/{broj_sj}',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti/{smjestajni_objekt_id}/smjestajne_jedinice/{broj_sj}',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti/{smjestajni_objekt_id}/smjestajne_jedinice/{broj_sj}',
      p_method             => 'GET',
      p_name               => 'broj_sj',
      p_bind_variable_name => 'broj_sj',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti/{smjestajni_objekt_id}/smjestajne_jedinice/{broj_sj}',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti/{smjestajni_objekt_id}/smjestajne_jedinice/{broj_sj}',
      p_method             => 'GET',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti/{smjestajni_objekt_id}/smjestajne_jedinice/{broj_sj}',
      p_method             => 'GET',
      p_name               => 'smjestajne_jedinice',
      p_bind_variable_name => 'smjestajne_jedinice',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti/{smjestajni_objekt_id}/smjestajne_jedinice/{broj_sj}',
      p_method             => 'GET',
      p_name               => 'smjestajni_objekt_id',
      p_bind_variable_name => 'smjestajni_objekt_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'vrste_poreznih_placanja/{vrsta_poreznih_placanja_id}',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'vrste_poreznih_placanja/{vrsta_poreznih_placanja_id}',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
    l_korisnik              VARCHAR2(40);
    l_shema VARCHAR2(40);

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    execute immediate ''begin :vrsta_poreznog_placanja := '' || l_shema || ''PRA_POS_PKA.VPPLA_NAZIV(:vrsta_poreznih_placanja_id); end;''
        using out :vrsta_poreznog_placanja, in :vrsta_poreznih_placanja_id;

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'vrste_poreznih_placanja/{vrsta_poreznih_placanja_id}',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'vrste_poreznih_placanja/{vrsta_poreznih_placanja_id}',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'vrste_poreznih_placanja/{vrsta_poreznih_placanja_id}',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'vrste_poreznih_placanja/{vrsta_poreznih_placanja_id}',
      p_method             => 'GET',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'vrste_poreznih_placanja/{vrsta_poreznih_placanja_id}',
      p_method             => 'GET',
      p_name               => 'vrsta_poreznih_placanja_id',
      p_bind_variable_name => 'vrsta_poreznih_placanja_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'vrste_poreznih_placanja/{vrsta_poreznih_placanja_id}',
      p_method             => 'GET',
      p_name               => 'vrsta_poreznog_placanja',
      p_bind_variable_name => 'vrsta_poreznog_placanja',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);

  ORDS.DEFINE_MODULE(
      p_module_name    => 'pra_pos_pkakar',
      p_base_path      => '/pra_pos_pkakar/',
      p_items_per_page =>  25,
      p_status         => 'PUBLISHED',
      p_comments       => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_pkakar',
      p_pattern        => 'agencije/{agencija_id}',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_pkakar',
      p_pattern        => 'agencije/{agencija_id}',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
    l_korisnik              VARCHAR2(40);
    l_shema VARCHAR2(40);

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    execute immediate ''begin :agencije := '' || l_shema || ''PRA_POS_PKAKAR.AGE_BY_ID(:agencija_id); end;''
        using out :agencije, in :agencija_id;

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'agencije/{agencija_id}',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'agencije/{agencija_id}',
      p_method             => 'GET',
      p_name               => 'agencija_id',
      p_bind_variable_name => 'agencija_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'agencije/{agencija_id}',
      p_method             => 'GET',
      p_name               => 'agencije',
      p_bind_variable_name => 'agencije',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'agencije/{agencija_id}',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'agencije/{agencija_id}',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'agencije/{agencija_id}',
      p_method             => 'GET',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_pkakar',
      p_pattern        => 'kase/{kasa_id}/gantner_narukvica/{broj_kartice}',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_pkakar',
      p_pattern        => 'kase/{kasa_id}/gantner_narukvica/{broj_kartice}',
      p_method         => 'DELETE',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
    l_korisnik              VARCHAR2(40);
    l_shema VARCHAR2(40);

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    execute immediate ''begin :agencije := '' || l_shema || ''PRA_POS_PKAKAR.PONISTI_GANTNER_NARUKVICU(:kasa_id, :broj_kartice, :kolicinakckar, :kolicinapkakar); end;''
        using in :kasa_id, in :broj_kartice, out :kolicinakckar, out :kolicinapkakar;

	EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'kase/{kasa_id}/gantner_narukvica/{broj_kartice}',
      p_method             => 'DELETE',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'kase/{kasa_id}/gantner_narukvica/{broj_kartice}',
      p_method             => 'DELETE',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'kase/{kasa_id}/gantner_narukvica/{broj_kartice}',
      p_method             => 'DELETE',
      p_name               => 'broj_kartice',
      p_bind_variable_name => 'broj_kartice',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'kase/{kasa_id}/gantner_narukvica/{broj_kartice}',
      p_method             => 'DELETE',
      p_name               => 'kasa_id',
      p_bind_variable_name => 'kasa_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'kase/{kasa_id}/gantner_narukvica/{broj_kartice}',
      p_method             => 'DELETE',
      p_name               => 'kolicinakckar',
      p_bind_variable_name => 'kolicinakckar',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'kase/{kasa_id}/gantner_narukvica/{broj_kartice}',
      p_method             => 'DELETE',
      p_name               => 'kolicinapkakar',
      p_bind_variable_name => 'kolicinapkakar',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'kase/{kasa_id}/gantner_narukvica/{broj_kartice}',
      p_method             => 'DELETE',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'kase/{kasa_id}/gantner_narukvica/{broj_kartice}',
      p_method             => 'DELETE',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_pkakar',
      p_pattern        => 'metcvor/{metcvor_sifra}/adrese/{adresa_id}',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_pkakar',
      p_pattern        => 'metcvor/{metcvor_sifra}/adrese/{adresa_id}',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
    l_korisnik              VARCHAR2(40);
    l_shema VARCHAR2(40);

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    execute immediate ''begin :adrese := '' || l_shema || ''PRA_POS_PKAKAR.PKAADR_BY_ID(:metcvor_sifra, :adresa_id); end;''
        using out :adrese, in :metcvor_sifra, in :adresa_id;

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'metcvor/{metcvor_sifra}/adrese/{adresa_id}',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'metcvor/{metcvor_sifra}/adrese/{adresa_id}',
      p_method             => 'GET',
      p_name               => 'adresa_id',
      p_bind_variable_name => 'adresa_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'metcvor/{metcvor_sifra}/adrese/{adresa_id}',
      p_method             => 'GET',
      p_name               => 'adrese',
      p_bind_variable_name => 'adrese',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'metcvor/{metcvor_sifra}/adrese/{adresa_id}',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'metcvor/{metcvor_sifra}/adrese/{adresa_id}',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'metcvor/{metcvor_sifra}/adrese/{adresa_id}',
      p_method             => 'GET',
      p_name               => 'metcvor_sifra',
      p_bind_variable_name => 'metcvor_sifra',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'metcvor/{metcvor_sifra}/adrese/{adresa_id}',
      p_method             => 'GET',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_pkakar',
      p_pattern        => 'metcvor/{metcvor_sifra}/gosti/{gost_id}',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_pkakar',
      p_pattern        => 'metcvor/{metcvor_sifra}/gosti/{gost_id}',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
    l_korisnik              VARCHAR2(40);
    l_shema VARCHAR2(40);

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    execute immediate ''begin :gosti := '' || l_shema || ''PRA_POS_PKAKAR.GOST_BY_ID(:metcvor_sifra, :gost_id); end;''
        using out :gosti, in :metcvor_sifra, in :gost_id;

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'metcvor/{metcvor_sifra}/gosti/{gost_id}',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'metcvor/{metcvor_sifra}/gosti/{gost_id}',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'metcvor/{metcvor_sifra}/gosti/{gost_id}',
      p_method             => 'GET',
      p_name               => 'gost_id',
      p_bind_variable_name => 'gost_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'metcvor/{metcvor_sifra}/gosti/{gost_id}',
      p_method             => 'GET',
      p_name               => 'gosti',
      p_bind_variable_name => 'gosti',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'metcvor/{metcvor_sifra}/gosti/{gost_id}',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'metcvor/{metcvor_sifra}/gosti/{gost_id}',
      p_method             => 'GET',
      p_name               => 'metcvor_sifra',
      p_bind_variable_name => 'metcvor_sifra',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'metcvor/{metcvor_sifra}/gosti/{gost_id}',
      p_method             => 'GET',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_pkakar',
      p_pattern        => 'nfc_broj/uuid/{uuid}/gosti/{gost_id}',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_pkakar',
      p_pattern        => 'nfc_broj/uuid/{uuid}/gosti/{gost_id}',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
    l_korisnik              VARCHAR2(40);
    l_shema VARCHAR2(40);

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    execute immediate ''begin :broj_kartice := '' || l_shema || ''PRA_POS_PKAKAR.NFC_BROJ(:uuid, :gost_id); end;''
        using out :broj_kartice, in :uuid, in :gost_id;

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'nfc_broj/uuid/{uuid}/gosti/{gost_id}',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'nfc_broj/uuid/{uuid}/gosti/{gost_id}',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'nfc_broj/uuid/{uuid}/gosti/{gost_id}',
      p_method             => 'GET',
      p_name               => 'broj_kartice',
      p_bind_variable_name => 'broj_kartice',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'nfc_broj/uuid/{uuid}/gosti/{gost_id}',
      p_method             => 'GET',
      p_name               => 'gost_id',
      p_bind_variable_name => 'gost_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'nfc_broj/uuid/{uuid}/gosti/{gost_id}',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'nfc_broj/uuid/{uuid}/gosti/{gost_id}',
      p_method             => 'GET',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'nfc_broj/uuid/{uuid}/gosti/{gost_id}',
      p_method             => 'GET',
      p_name               => 'uuid',
      p_bind_variable_name => 'uuid',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_pkakar',
      p_pattern        => 'provjera_kartice/kase/{kasa_id}',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_pkakar',
      p_pattern        => 'provjera_kartice/kase/{kasa_id}',
      p_method         => 'POST',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
    l_korisnik              VARCHAR2(40);
    l_shema VARCHAR2(40);

    /**
    * POST BODY PARAMETRI:
    *   broj_kartice
    *   pin
    *   datum_zavrsetka
    *   iznos
    */

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    execute immediate ''begin '' || l_shema || ''PRA_POS_PKAKAR.PROVJERI_PKAKAR(
        :kasa_id,
        :broj_kartice,
        :pin,
        :datum,
        :iznos,
        :kasa_oib,
        :kartica_id,
        :metcvor_sifra,
        :cjenik_id,
        :stopa_popusta_pos1,
        :stopa_popusta_pos2,
        :gost_id,
        :agencija_id,
        :adresa_id,
        :oznaka_prepaid,
        :neiskoristen_iznos,
        :ime,
        :prezime,
        :cjenik2_id,
        :organizacijska_jedinica_sifra,
        :knjiga_racuna_kartice_sifra,
        :knjiga_racuna_kartice_naziv,
        :metcvor_sifra2,
        :iznos_povrat
    ); end;''
    using
        in :kasa_id,
        in :broj_kartice,
        in :pin,
        in :datum,
        in :iznos,
        in :kasa_oib,
        out :kartica_id,
        out :metcvor_sifra,
        out :cjenik_id,
        out :stopa_popusta_pos1,
        out :stopa_popusta_pos2,
        out :gost_id,
        out :agencija_id,
        out :adresa_id,
        out :oznaka_prepaid,
        out :neiskoristen_iznos,
        out :ime,
        out :prezime,
        out :cjenik2_id,
        out :organizacijska_jedinica_sifra,
        out :knjiga_racuna_kartice_sifra,
        out :knjiga_racuna_kartice_naziv,
        out :metcvor_sifra2,
        out :iznos_povrat;

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/kase/{kasa_id}',
      p_method             => 'POST',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/kase/{kasa_id}',
      p_method             => 'POST',
      p_name               => 'adresa_id',
      p_bind_variable_name => 'adresa_id',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/kase/{kasa_id}',
      p_method             => 'POST',
      p_name               => 'agencija_id',
      p_bind_variable_name => 'agencija_id',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/kase/{kasa_id}',
      p_method             => 'POST',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/kase/{kasa_id}',
      p_method             => 'POST',
      p_name               => 'cjenik2_id',
      p_bind_variable_name => 'cjenik2_id',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/kase/{kasa_id}',
      p_method             => 'POST',
      p_name               => 'cjenik_id',
      p_bind_variable_name => 'cjenik_id',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/kase/{kasa_id}',
      p_method             => 'POST',
      p_name               => 'gost_id',
      p_bind_variable_name => 'gost_id',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/kase/{kasa_id}',
      p_method             => 'POST',
      p_name               => 'ime',
      p_bind_variable_name => 'ime',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/kase/{kasa_id}',
      p_method             => 'POST',
      p_name               => 'iznos_povrat',
      p_bind_variable_name => 'iznos_povrat',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/kase/{kasa_id}',
      p_method             => 'POST',
      p_name               => 'kartica_id',
      p_bind_variable_name => 'kartica_id',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/kase/{kasa_id}',
      p_method             => 'POST',
      p_name               => 'kasa_id',
      p_bind_variable_name => 'kasa_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/kase/{kasa_id}',
      p_method             => 'POST',
      p_name               => 'knjiga_racuna_kartice_naziv',
      p_bind_variable_name => 'knjiga_racuna_kartice_naziv',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/kase/{kasa_id}',
      p_method             => 'POST',
      p_name               => 'knjiga_racuna_kartice_sifra',
      p_bind_variable_name => 'knjiga_racuna_kartice_sifra',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/kase/{kasa_id}',
      p_method             => 'POST',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/kase/{kasa_id}',
      p_method             => 'POST',
      p_name               => 'metcvor_sifra',
      p_bind_variable_name => 'metcvor_sifra',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/kase/{kasa_id}',
      p_method             => 'POST',
      p_name               => 'metcvor_sifra2',
      p_bind_variable_name => 'metcvor_sifra2',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/kase/{kasa_id}',
      p_method             => 'POST',
      p_name               => 'neiskoristen_iznos',
      p_bind_variable_name => 'neiskoristen_iznos',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/kase/{kasa_id}',
      p_method             => 'POST',
      p_name               => 'organizacijska_jedinica_sifra',
      p_bind_variable_name => 'organizacijska_jedinica_sifra',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/kase/{kasa_id}',
      p_method             => 'POST',
      p_name               => 'oznaka_prepaid',
      p_bind_variable_name => 'oznaka_prepaid',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/kase/{kasa_id}',
      p_method             => 'POST',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/kase/{kasa_id}',
      p_method             => 'POST',
      p_name               => 'prezime',
      p_bind_variable_name => 'prezime',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/kase/{kasa_id}',
      p_method             => 'POST',
      p_name               => 'stopa_popusta_pos1',
      p_bind_variable_name => 'stopa_popusta_pos1',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/kase/{kasa_id}',
      p_method             => 'POST',
      p_name               => 'stopa_popusta_pos2',
      p_bind_variable_name => 'stopa_popusta_pos2',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_pkakar',
      p_pattern        => 'provjera_kartice/pin/metcvor/{metcvor_sifra}/kartica/{kartica_id}',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_pkakar',
      p_pattern        => 'provjera_kartice/pin/metcvor/{metcvor_sifra}/kartica/{kartica_id}',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
    l_korisnik              VARCHAR2(40);
    l_shema VARCHAR2(40);

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    execute immediate ''begin :treba_pin := '' || l_shema || ''PRA_POS_PKAKAR.PKAKAR_TREBA_PIN(:kartica_id, :metcvor_sifra); end;''
        using out :treba_pin, in :kartica_id, in :metcvor_sifra;

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/pin/metcvor/{metcvor_sifra}/kartica/{kartica_id}',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/pin/metcvor/{metcvor_sifra}/kartica/{kartica_id}',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/pin/metcvor/{metcvor_sifra}/kartica/{kartica_id}',
      p_method             => 'GET',
      p_name               => 'kartica_id',
      p_bind_variable_name => 'kartica_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/pin/metcvor/{metcvor_sifra}/kartica/{kartica_id}',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/pin/metcvor/{metcvor_sifra}/kartica/{kartica_id}',
      p_method             => 'GET',
      p_name               => 'metcvor_sifra',
      p_bind_variable_name => 'metcvor_sifra',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/pin/metcvor/{metcvor_sifra}/kartica/{kartica_id}',
      p_method             => 'GET',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/pin/metcvor/{metcvor_sifra}/kartica/{kartica_id}',
      p_method             => 'GET',
      p_name               => 'treba_pin',
      p_bind_variable_name => 'treba_pin',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_pkakar',
      p_pattern        => 'provjera_kartice/pin/metcvor/{metcvor_sifra}/kartica/{kartica_id}',
      p_method         => 'POST',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
    l_korisnik              VARCHAR2(40);
    l_shema VARCHAR2(40);

    /**
    * POST BODY PARAMETRI:
    *   pin
    */

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    execute immediate ''begin :pin_status := '' || l_shema || ''PRA_POS_PKAKAR.PKAKAR_PIN_OK(:kartica_id, :metcvor_sifra, :pin); end;''
        using out :pin_status, in :kartica_id, in :metcvor_sifra, in :pin;

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/pin/metcvor/{metcvor_sifra}/kartica/{kartica_id}',
      p_method             => 'POST',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/pin/metcvor/{metcvor_sifra}/kartica/{kartica_id}',
      p_method             => 'POST',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/pin/metcvor/{metcvor_sifra}/kartica/{kartica_id}',
      p_method             => 'POST',
      p_name               => 'kartica_id',
      p_bind_variable_name => 'kartica_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/pin/metcvor/{metcvor_sifra}/kartica/{kartica_id}',
      p_method             => 'POST',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/pin/metcvor/{metcvor_sifra}/kartica/{kartica_id}',
      p_method             => 'POST',
      p_name               => 'metcvor_sifra',
      p_bind_variable_name => 'metcvor_sifra',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/pin/metcvor/{metcvor_sifra}/kartica/{kartica_id}',
      p_method             => 'POST',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/pin/metcvor/{metcvor_sifra}/kartica/{kartica_id}',
      p_method             => 'POST',
      p_name               => 'pin_status',
      p_bind_variable_name => 'pin_status',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_pkakar',
      p_pattern        => 'racuni',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_pkakar',
      p_pattern        => 'racuni',
      p_method         => 'POST',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
    l_korisnik              VARCHAR2(40);
    l_shema VARCHAR2(40);

    /**
    * POST BODY PARAMETRI:
    *   kartica_id
    *   metcvor_sifra
    *   pin
    *   kasa_id
    *   poslovna_godinap
    *   redni_broj
    *   datum
    *   iznos
    *   oznaka
    *   cjenik_id
    *   iznos_racuna
    *   iznos_popusta
    */

    l_pkakar_rn_id number;

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    execute immediate ''begin '' || l_shema || ''PRA_POS_PKAKAR.brisi_pkakarrnk(:racun_id, :broj_obrisanih); end;''
        using in :racun_id, out :broj_obrisanih;

    execute immediate ''begin '' || l_shema || ''PRA_POS_PKAKAR.PUNI_PKAKARRNK(
            :kartica_id,
            :metcvor_sifra,
            :pin,
            :kasa_id,
            :poslovna_godinap,
            :redni_broj,
            :datum,
            :iznos,
            :oznaka,
            :organizacijska_jedinica_id,
            :smjestajni_objekt_id,
            :cjenik_id,
            :iznos_racuna,
            :iznos_popusta,
            :pkakar_rn_id
    ); end;''
    using
            in :kartica_id,
            in :metcvor_sifra,
            in :pin,
            in :kasa_id,
            in :poslovna_godinap,
            in :redni_broj,
            in TO_DATE( :datum, ''YYYY-MM-DD"T"HH24:MI'' ),
            in :iznos,
            in :oznaka,
            out :organizacijska_jedinica_id,
            out :smjestajni_objekt_id,
            in :cjenik_id,
            in :iznos_racuna,
            in :iznos_popusta,
            out l_pkakar_rn_id;

    :pkakar_rn_id := l_pkakar_rn_id;

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'racuni',
      p_method             => 'POST',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'racuni',
      p_method             => 'POST',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'racuni',
      p_method             => 'POST',
      p_name               => 'broj_obrisanih',
      p_bind_variable_name => 'broj_obrisanih',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'racuni',
      p_method             => 'POST',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'racuni',
      p_method             => 'POST',
      p_name               => 'organizacijska_jedinica_id',
      p_bind_variable_name => 'organizacijska_jedinica_id',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'racuni',
      p_method             => 'POST',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'racuni',
      p_method             => 'POST',
      p_name               => 'pkakar_rn_id',
      p_bind_variable_name => 'pkakar_rn_id',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'racuni',
      p_method             => 'POST',
      p_name               => 'smjestajni_objekt_id',
      p_bind_variable_name => 'smjestajni_objekt_id',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_pkakar',
      p_pattern        => 'racuni',
      p_method         => 'PUT',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
    l_korisnik              VARCHAR2(40);
    l_shema VARCHAR2(40);

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    execute immediate ''begin '' || l_shema || ''PRA_POS_PKAKAR.brisi_pkakarrnk(:racun_id, :broj_obrisanih); end;''
        using in :racun_id, out :broj_obrisanih;

    --pra_pos_pkakar.brisi_pkakarrnk(:racun_id, :broj_obrisanih);

    execute immediate ''begin '' || l_shema || ''PRA_POS_PKAKAR.PONISTI_PKAKARRNK(
            :broj_kartice,
            :organizacijska_jedinica_id,
            :kasa_id,
            :poslovna_godinapp,
            :rbrpp,
            :poslovna_godinap,
            :rbrp,
            :datum,
            :iznos,
            :oznaka,
            :oznaka_ponisten,
            :cjenik_id,
            :iznos_racuna,
            :iznos_popusta,
            :pkakar_rn_id
    ); end;''
    using
            in :broj_kartice,
            in :organizacijska_jedinica_id,
            in :kasa_id,
            in :poslovna_godinapp,
            in :rbrpp,
            in :poslovna_godinap,
            in :rbrp,
            in TO_DATE( :datum, ''YYYY-MM-DD"T"HH24:MI'' ),
            in :iznos,
            in :oznaka,
            out :oznaka_ponisten,
            in :cjenik_id,
            in :iznos_racuna,
            in :iznos_popusta,
            out :pkakar_rnk_id;

    EXCEPTION
        WHEN api_exception THEN
            rollback;
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'racuni',
      p_method             => 'PUT',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'racuni',
      p_method             => 'PUT',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'racuni',
      p_method             => 'PUT',
      p_name               => 'broj_obrisanih',
      p_bind_variable_name => 'broj_obrisanih',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'racuni',
      p_method             => 'PUT',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'racuni',
      p_method             => 'PUT',
      p_name               => 'oznaka_ponisten',
      p_bind_variable_name => 'oznaka_ponisten',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'racuni',
      p_method             => 'PUT',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'racuni',
      p_method             => 'PUT',
      p_name               => 'pkakar_rnk_id',
      p_bind_variable_name => 'pkakar_rnk_id',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_pkakar',
      p_pattern        => 'racuni/{racun_id}',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_pkakar',
      p_pattern        => 'racuni/{racun_id}',
      p_method         => 'DELETE',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         =>
'DECLARE
    l_vlasnikpodatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 2;
    l_korisnik              VARCHAR2(40);
    l_shema VARCHAR2(40);

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    pra_zmp_s.provjeri_p2 (:p1, l_korisnik, l_vlasnikpodatka);

    IF l_korisnik IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka (null);
        RAISE auth_exception;
    end if;

    IF l_vlasnikpodatka IS NOT NULL THEN  -- multitenant
        pra_zmp_context.set_vlasnikpodatka (l_vlasnikpodatka);
        pra_zmp_context.set_korisnik (l_korisnik);
        l_shema := null;
    ELSE
        l_shema := l_korisnik || ''.'';
    END IF;

    execute immediate ''begin '' || l_shema || ''PRA_POS_PKAKAR.brisi_pkakarrnk(:racun_id, :broj_obrisanih); end;''
        using in :racun_id, out :broj_obrisanih;

    EXCEPTION
        WHEN api_exception THEN
            ROLLBACK;
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'racuni/{racun_id}',
      p_method             => 'DELETE',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'racuni/{racun_id}',
      p_method             => 'DELETE',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'racuni/{racun_id}',
      p_method             => 'DELETE',
      p_name               => 'broj_obrisanih',
      p_bind_variable_name => 'broj_obrisanih',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'racuni/{racun_id}',
      p_method             => 'DELETE',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'racuni/{racun_id}',
      p_method             => 'DELETE',
      p_name               => 'p1',
      p_bind_variable_name => 'p1',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'racuni/{racun_id}',
      p_method             => 'DELETE',
      p_name               => 'racun_id',
      p_bind_variable_name => 'racun_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);

  ORDS.CREATE_ROLE(p_role_name  => 'PosUserRole');

  l_roles(1)   := 'PosUserRole';
  l_modules(1) := 'pra_pos_gas';
  l_modules(2) := 'pra_pos_pka';
  l_modules(3) := 'pra_pos_pkakar';

  ORDS.DEFINE_PRIVILEGE(
      p_privilege_name => 'PosUserPrivilege',
      p_roles          => l_roles,
      p_patterns       => l_patterns,
      p_modules        => l_modules,
      p_label          => '',
      p_description    => '',
      p_comments       => NULL);
END;
